      PROGRAM PREBUG
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          PREBUG           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          BUGOUT PREPROCESSOR                     
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-3
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA  94035                
C*          (415) 604-5578
C*                                                  
C*     PURPOSE :
C*          THIS PROGRAM WAS WRITTEN TO MERGE THE CALLS AND TRACER
C*            PROGRAMS WRITTEN BY ART RAGOSTA.
C*          THIS PROGRAM DOES TWO THINGS --                               
C*          1.  CHECKS THE NUMBER OF ARGUMENTS IN CALL STATEMENTS,      
C*              COMPARING THEM TO THE NUMBER IN THE SUBROUTINE          
C*              STATEMENT AND OTHER CALL STATEMENTS; AND                
C*          2.  INSERTS CODE INTO A FORTRAN PROGRAM TO CALCULATE        
C*              TRACE, CPU TIME AND SUBSCRIPT LIMITS INFORMATION.           
C*
C*     COMMON BLOCKS :
C*          SWITCH, STYPE, STATMT
C*
C*     FILE REFERENCES :
C*          NOPT   - FILE CONTAINING THE RUN-TIME OPTIONS
C*          NREAD  - SOURCE CODE INPUT
C*          NPRINT - PRINTOUT
C*          NSAVE  - SAVE/RESTORE FILE
C*          NSUMM  - SUMMARY PRINTOUT FILE
C*          NCODE  - OUTPUT OF INSTRUMENTED CODE
C*
C*     SUBPROGRAM REFERENCES :
C*          OPTION, GETCRD, GETSTM, CATEG, NAMEX, ARGEX, CHECK, XRETUR,
C*          SUBPRO, XSTOP, XEND, PUTSTM
C*
C*
C*     ASSUMPTIONS AND RESTRICTIONS :
C*          MAIN MUST EITHER BE THE FIRST SUBPROGRAM, OR IT MUST HAVE
C*          A 'PROGRAM' CARD.
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     CALLS VERSION : 
C*          VERSION II.7
C* 
C*     CALLS CHANGE HISTORY : 
C*          08/26/86     READ MULTIPLE LINES FROM OPTIONS FILE
C*          03/24/86     TAB REMOVED, BUG IN CHARTR FIXED
C*          06/04/85     BUG FIXED IN ARGEX
C*          04/22/85     LITERAL STRINGS AS ARGUMENTS IMPROVED
C*          12/26/84     SAVE AND RESTORE OPTIONS ADDED
C*          06/05/84     SORT OPTION ADDED, MINOR BUGS FIXED
C*          03/12/84     CALL STATEMENT CROSS-REFERENCE MAP ADDED
C*          01/24/84     CONVERTED TO VAX
C*          10/13/83     INITIAL VERSION 
C*
C*     TRACER VERSION :
C*          VERSION II.8
C*
C*     TRACER CHANGE HISTORY :
C*          08/26/86     READ MULTIPLE LINES FROM OPTION FILE
C*          07/03/86     STATEMENT NUMBERS FIXED IN FUNCTION ASSURE
C*          06/24/86     ERROR IN CHECKING 'END' CARD FIXED
C*          10/31/85     'INCLUDE' STATEMENT ADDED
C*          09/19/85     'SAVE' STATEMENT ADDED
C*          07/30/85     BUG FIXED IN MAIN, FILENAME ADDED TO PRINTOUT
C*          04/22/85     STATEMENT CLASSIFICATION MADE MORE FOOLPROOF
C*          06/15/84     MINOR BUG FIX AND PRINTOUT REFORMATTED
C*          01/27/84     VAX VERSION
C*          10/04/83     INITIAL VERSION
C*
C*     VERSION AND DATE :
C*          VERSION III.4 - JUNE 1, 1988
C*
C*     CHANGE HISTORY :
C*          14-JUN-90    NOTIME DEFAULT, SOME VAX SPEC STMTS ADDED.
C*          16-APR-90    CPU CHECKING ACCURACY IMPROVED.
C*          01-JUN-88    ROUTINE GETSTM REPLACED WITH CALL TO MERLIB ROUTINE
C*          23-NOV-87    MODIFIED TO PRODUCE SUMMARY WHEN NO OPTIONS CHOSEN
C*          15-OCT-86    SLIGHT EFFICIENCY IMPROVEMENT, PRINTOUT FORMAT
C*          22-SEP-86    CALLS AND TRACER COMBINED
C*
C***********************************************************************
C*
      PARAMETER (MXCHR=12,MAXSTM=3000)
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / STYPE / TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $   TYPECE, TYPER, TYPEND, SPSTM
      COMMON / STATMT / STMT, EOF, CLABEL
      CHARACTER *(MAXSTM) STMT
      CHARACTER *(MXCHR) NAME
      CHARACTER *5 CLABEL
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      LOGICAL TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $        TYPECE, TYPER, TYPEND, SPSTM
      LOGICAL EOF
      LOGICAL ONLY, MAIN
C
      MAIN = .FALSE.
      CALL OPTION
      IF ( .NOT. RUNT  .AND.  .NOT. RUNC ) THEN
C
C --- NO OPTIONS CHOSEN, COPY INPUT AND EXIT
C                                   
10       IF (EOF) THEN
            CALL SUMMAR           
            STOP
         ENDIF
         CALL GETSTM (NREAD, STMT, LENST, CLABEL, EOF)
         IF (LENST .GT. MAXSTM) GO TO 100
         NSTMTS = NSTMTS + 1
         CALL PUTSTM (NCODE,CLABEL,STMT)
         NSTMTS = NSTMTS + 1
         GO TO 10
      ENDIF
C
C --- DO WHILE END-OF-FILE ON SOURCE NOT REACHED
C
30    IF (EOF) CALL ENDUP
      CALL GETSTM (NREAD, STMT, LENST, CLABEL, EOF)
      IF (LENST .GT. MAXSTM) GO TO 100
      NSTMTS = NSTMTS + 1
C
C --- CATEGORIZE THE STATEMENT
C
35    CALL CATEG
C
C --- CHECKING FOR CALLS
C
      IF ( RUNC  .AND. 
     $    (TYPEC .OR. TYPES .OR. TYPEF .OR. TYPEP .OR. TYPEE) ) THEN
         ONLY = .FALSE.
         CALL NAMEX(NAME,ONLY)
         CALL ARGEX(NUMBER)
         CALL CHECK(NAME,NUMBER)
      ENDIF
C
C --- CHECKING FOR TRACER
C
      IF (RUNT) THEN
         IF (TYPER) THEN
            CALL XRETUR
         ELSEIF (TYPES) THEN
            CALL SUBPRO ( 1 )
            GO TO 35
         ELSEIF (TYPEF) THEN
            CALL SUBPRO  ( 2 )
            GO TO 35
         ELSEIF (TYPEE) THEN
            CALL SUBPRO ( 3 )
            GO TO 35
         ELSEIF (TYPEST .OR. TYPECE) THEN
            CALL XSTOP
         ELSEIF (TYPEND) THEN
            CALL XEND
         ELSE
            IF (.NOT. MAIN) THEN
C
C ------------ CHECK TO SEE IF IT IS NON-EXECUTABLE
C
40             IF ((SPSTM) .OR. (TYPEP)) THEN
C
C --- LOOP UNTIL EXECUTABLE STATEMENT FOUND
C
                   CALL PUTSTM ( NCODE,CLABEL,STMT )
                   IF (EOF) CALL ENDUP
                   CALL GETSTM (NREAD, STMT, LENST, CLABEL, EOF)
                   IF (LENST .GT. MAXSTM) GO TO 100
                   NSTMTS = NSTMTS + 1
                   CALL CATEG
                   GO TO 40
               ENDIF
C
C --- AN EXECUTABLE STATEMENT HAS BEEN FOUND
C
               MAIN = .TRUE.
               WRITE ( NCODE, 910 )
C
C --- CATEGORIZE THE STATEMENT AND PROCESS AS USUAL
C
               GO TO 35
            ENDIF
         ENDIF
      ENDIF
      CALL PUTSTM ( NCODE,CLABEL,STMT )
      GO TO 30
100   WRITE(NPRINT,900) MAXSTM, STMT(1:72)
      CALL ENDUP
900   FORMAT (/
     $ ' ***** FATAL ERROR !',/
     $ ' STATEMENT LENGTH EXCEEDS PROGRAM DIMENSION OF ',I4,/,
     $ ' FIRST 72 CHARACTERS OF OFFENDING STATEMENT: ',/,
     $ ' "',A72,'"',/,
     $ ' PREPROCESSOR TERMINATED.')
910   FORMAT ( '      CALL Q1QINIT' )
      END
C
C---END PREBUG
C
      SUBROUTINE OPTION
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          OPTION           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          GET OPTION                              
C*
C*     AUTHOR :
C*          ART RAGOSTA
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA 94035                 
C*          (415) 694-5578                          
C*
C*     PURPOSE :
C*          EXTRACT THE RUN-TIME OPTIONS FROM THE OPTIONS FILE.         
C*          IF NO OPTIONS, THE DEFAULT OPTIONS ARE USED.                
C*
C*     COMMON BLOCKS :
C*          STORE, SWITCH, CHARTX, LITTLE, MISC, STATMT
C*
C*     FILE REFERENCES :
C*          NOPT
C*
C*     SUBPROGRAM REFERENCES :
C*          CAPS, RESTR
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     28-AUG-86 
C*
C*     CHANGE HISTORY :
C*          29-AUG-91    STARTNUM OPTION ADDED
C*          30-MAY-90    DEFAULT FOR TIME OPTION CHANGED TO NOTIME
C*          28-AUG-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (MXCHR=12)
      COMMON / STORE  / FUNNAM(50), SUBNAM(400), CALNAM(400), 
     $  NARGS(400), NARGC(400), NUMS, NUMF, NUMC, SAVE
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / CHARTX / CHRT(200), PROPST
      COMMON / LITTLE / NSUB, SAVNAM
      COMMON / MISC   / NUM, NUNIT, PUTSTP, PUTRET
      COMMON / STATMT / STMT, EOF, CLABEL
      CHARACTER *3000 STMT
      CHARACTER *200 CHRT
      CHARACTER *150 OPST,PROPST
      CHARACTER *20 SAVNAM
      CHARACTER *(MXCHR) FUNNAM, CALNAM, SUBNAM
      CHARACTER *5 CLABEL, TEMPNUM
      CHARACTER *1 DIGIT, FF
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      LOGICAL PUTSTP, PUTRET, SAVE, RESTOR, EOF
      DATA FF /12/
C
C --- FLAGS
C
      ISTART = 99997
      NOUT   = 1
      NUM    = 1
      NUNIT  = 6
      MAP    = .FALSE.
      LTIME  = .FALSE.
      LTRACE = .FALSE.
      LINDEX = .FALSE.
      RUNT   = .TRUE.
      RUNC   = .TRUE.
      SORT   = .TRUE.
      SAVE   = .FALSE.
      RESTOR = .FALSE.
      EOF    = .FALSE.
C
C --- UNIT NUMBERS
C
      NDIR   = 90
      NOPT   = 91
      NREAD  = 92
      NPRINT = 93
      NCODE  = 94
      NSAVE  = 95
      NSUMM  = 96
C
C --- COUNTERS
C
      NERROR = 0
      NSTMTS = 0
      NUMF   = 0
      NUMC   = 0
      NUMS   = 1
      NSUB   = 1
      SUBNAM(1) = 'MAIN        '
      CHRT(1)   = ' '
      SAVNAM = 'CALSAVE.DAT'
      OPEN ( UNIT=NCODE, STATUS='NEW', CARRIAGECONTROL='LIST', ERR=100 )
      OPEN ( UNIT=NPRINT,STATUS='NEW', CARRIAGECONTROL='LIST', ERR=100 )
      WRITE (NPRINT,910) FF
      OPEN ( UNIT=NREAD,STATUS='OLD', ERR=200 )
C
C --- READ IN MERLIB ROUTINE NAMES AND ARGUMENTS
C
      CALL GETMRL
C
      OPEN ( NOPT,STATUS='OLD',ERR=20 )
3     READ ( NOPT,910,END=20 ) OPST
      CALL CAPS(OPST)
C
C --- GET CALLS OPTIONS
C
      IF (INDEX(OPST,'NOCALL') .NE. 0) RUNC = .FALSE.
      IF (INDEX(OPST,'NOSORT') .NE. 0) SORT = .FALSE.
      IF (INDEX(OPST,'SAVE') .NE. 0) SAVE = .TRUE.
      IF (INDEX(OPST,'RESTORE') .NE. 0) RESTOR = .TRUE.
      IF (INDEX(OPST,'SAVENAME') .NE. 0) THEN
         N     = INDEX(OPST,'SAVENAME')
         IF (N .NE. 0) THEN
            I = N+10
            N = I
5           N = N + 1
            IF (OPST(N:N) .EQ. '''') THEN
               SAVNAM = OPST(I:N-1)
               GO TO 7
            ENDIF
            IF (N .LT. 132) GO TO 5
         ENDIF
      ENDIF
7     IF (INDEX(OPST,'PRINT=') .NE. 0) THEN
         N     = INDEX(OPST,'PRINT=') + 6
         IF (N .NE. 6)THEN
            NOUT = ICHAR(OPST(N:N)) - ICHAR('0')
            IF(NOUT.LT.0 .OR. NOUT.GT.2)NOUT = 1
         ENDIF
      ENDIF
      IF (INDEX(OPST,'STARTNUM=') .NE. 0) THEN
         N = INDEX(OPST,'STARTNUM=') + 9
         IF (N .NE. 9) THEN
            I = N 
            L = LENGTH (OPST)
9           N = N + 1
            IF ((OPST(N:N) .EQ. ',') .OR. (N .GT. L)) THEN
               TEMPNUM = OPST (I:N-1)
               GO TO 11
            ENDIF
            IF (N .LE. L) GO TO 9
11          CALL RIGHT (TEMPNUM)
            READ (TEMPNUM,915,ERR=13) ISTART
            IF ((ISTART .GT. 99997) .OR. (ISTART .LE. 0)) ISTART = 99997
         ENDIF
      ENDIF
13    IF (INDEX(OPST,'MAPCA').NE.0  .AND.  
     $    INDEX(OPST,'NOMAPCA').EQ.0) THEN
         MAP = .TRUE.
      ENDIF
C
C --- GET TRACER OPTIONS
C
      IF (INDEX(OPST,'TIME') .NE. 0) THEN
         IF (INDEX(OPST,'NOTIME') .EQ. 0) LTIME = .TRUE.
      ENDIF
      IF (INDEX(OPST,'TRACE') .NE. 0) THEN
         IF (INDEX(OPST,'NOTRACE') .EQ. 0) LTRACE = .TRUE.
      ENDIF
C
C --- INDEX IS ALWAYS .FALSE. IN THE VAX VERSION
C
C      IF (INDEX(OPST,'INDEX') .NE. 0) THEN
C         IF (INDEX(OPST,'NOINDEX') .EQ. 0) LINDEX = .TRUE.
C      ENDIF
C
      IF (INDEX(OPST,'UNIT=') .NE. 0) THEN
         IU = INDEX(OPST,'UNIT=')
         IF (IU .NE. 0) THEN
            IU = IU + 5
            DIGIT = OPST(IU:IU)
            IU = ICHAR(DIGIT) - ICHAR('0')
            IF ((IU .GT. 0) .AND. (IU .LT. 10)) NUNIT = IU
         ENDIF
      ENDIF
      GO TO 3
20    IF ((.NOT. LTIME) .AND. (.NOT. LTRACE) .AND.
     $   (.NOT. LINDEX)) RUNT = .FALSE.
C
C --- REBUILD OPTION STRING FOR PRINTOUT
C
      PROPST = ' '
      IOP  = 1
C
C --- CALLS 
C
      IF ( RUNC ) THEN
         PROPST(IOP:IOP+6) = 'CALLS, '
         IOP = IOP + 7
      ELSE
         PROPST(IOP:IOP+8) = 'NOCALLS, '
         IOP = IOP + 9
      ENDIF
      IF ( MAP ) THEN
         PROPST(IOP:IOP+9) = 'MAPCALLS, '
         IOP = IOP + 10
      ELSE
         PROPST(IOP:IOP+11) = 'NOMAPCALLS, '
         IOP = IOP + 12
      ENDIF
      IF ( SORT ) THEN
         PROPST(IOP:IOP+5) = 'SORT, '
         IOP = IOP + 6
      ELSE
         PROPST(IOP:IOP+7) = 'NOSORT, '
         IOP = IOP + 8
      ENDIF
      IF ( SAVE ) THEN
         PROPST(IOP:IOP+6) = 'SAVE, '
         IOP = IOP + 7
      ENDIF
      IF ( RESTOR ) THEN
         PROPST(IOP:IOP+9) = 'RESTORE, '
         IOP = IOP + 10
      ENDIF
      PROPST(IOP:IOP+5) = 'PRINT='
      IOP = IOP + 6
      PROPST(IOP:IOP) = CHAR(ICHAR('0')+NOUT)
      IOP = IOP + 1
      PROPST(IOP:IOP+32) = ', SAVENAME=''' // SAVNAM // ''''
      IOP = IOP + 33
C
C --- TRACER
C
      IF ( LTIME ) THEN
         PROPST(IOP:IOP+7)= ', TIME, '
         IOP = IOP + 8
      ELSE
         PROPST(IOP:IOP+9)= ', NOTIME, '
         IOP = IOP + 10
      ENDIF
      IF ( LTRACE ) THEN
         PROPST(IOP:IOP+6)= 'TRACE, '
         IOP = IOP + 7
      ELSE
         PROPST(IOP:IOP+8)= 'NOTRACE, '
         IOP = IOP + 9
      ENDIF
      IF ( LINDEX ) THEN
         PROPST(IOP:IOP+4)= 'INDEX'
         IOP = IOP + 5
      ELSE
         PROPST(IOP:IOP+6)= 'NOINDEX'
         IOP = IOP + 7
      ENDIF
      IF (IU .NE. 0) THEN
         PROPST(IOP:IOP+6)=', UNIT='
         IOP = IOP + 7
         PROPST(IOP:IOP) = CHAR(ICHAR('0')+NUNIT)
      ENDIF
      PROPST(IOP:IOP+10)= ', STARTNUM='
      IOP = IOP + 11
      WRITE (TEMPNUM,915) ISTART
      PROPST = PROPST(1:LENGTH(PROPST))//TEMPNUM(1:LENGTH(TEMPNUM))
      IF ( RESTOR ) CALL RESTR
      RETURN
100   WRITE ( NPRINT, 920 )
      STOP
200   WRITE ( NPRINT, 930 )
      STOP
910   FORMAT (A)
915   FORMAT (I5)
920   FORMAT ( ' ****** FATAL ERROR... UNABLE TO OPEN OUTPUT FILE.')
930   FORMAT ( ' ****** FATAL ERROR... UNABLE TO OPEN INPUT FILE.')
      END
C
C---END OPTION
C
      SUBROUTINE GETMRL 
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          GETMRL           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          GETMRL
C*
C*     AUTHOR :
C*          LAURA JURGELEIT
C*          MS 207-5
C*          AMES RESEARCH CENTER
C*          MOFFETT FIELD, CA  94035
C*          (415) 694-5578
C*
C*     PURPOSE :
C*          READ MERLIB ROUTINE NAMES AND NUMBER OF ARGUMENTS
C*          FOR CALLS CHECKING LATER
C*
C*     COMMON BLOCKS :
C*          SWITCH, MERLIB
C*
C*     ASSUMPTIONS AND RESTRICTIONS :
C*          EXPECTS FILE 'PREBUG.DAT' IN LOGICAL 'SYS$SYSTEM:'
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0  -   2-JUL-1987
C*
C*     CHANGE HISTORY :
C*           2-JUL-1987  -  INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (MXCHR=12,MXMRLB=200)
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / MERLIB / MNAME(MXMRLB), NARGM(MXMRLB), NUMRLB
      CHARACTER *(MXCHR) MNAME
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
C
      NMRL = 1
      OPEN (UNIT=NMRL, FILE='SYS$SYSTEM:PREBUG.DAT', READONLY,
     $  STATUS='OLD', ERR=1000)
      NUMRLB = 1
10    READ (NMRL,900,ERR=2000,END=100) MNAME(NUMRLB), NARGM(NUMRLB)
      NUMRLB = NUMRLB + 1
      GO TO 10
100   NUMRLB = NUMRLB - 1
      RETURN    
C
1000  WRITE (NPRINT, 910)
      NUMRLB = 0
      RETURN
2000  WRITE (NPRINT, 920)
      NUMRLB = 0
      RETURN
900   FORMAT (A12,I2)
910   FORMAT (' ***** ERROR OPENING MERLIB FILE - ',
     $        '       NO MERLIB NAMES WILL BE CHECKED.')
920   FORMAT (' ***** ERROR READING MERLIB FILE - ',
     $        '       NO MERLIB NAMES WILL BE CHECKED.')
      END
C
C---END GETMRL
C
      SUBROUTINE RESTR
C* 
C*                  ******************************* 
C*                  ******************************* 
C*                  **                           ** 
C*                  **          RESTR            ** 
C*                  **                           ** 
C*                  ******************************* 
C*                  ******************************* 
C* 
C*     SUBPROGRAM : 
C*          RESTORE
C* 
C*     AUTHOR : 
C*          ART RAGOSTA 
C*          MS 207-5 
C*          AMES RESEARCH CENTER 
C*          MOFFETT FIELD, CALIF 94035 
C*          (415)965-5578 
C* 
C*     PURPOSE : 
C*          RESTORE THE STATUS FROM A PREVIOUS RUN.
C* 
C*     COMMON BLOCKS : 
C*          STORE, SWITCH, LITTLE
C* 
C*     FILE REFERENCES : 
C*          NSAVE
C* 
C*     ERROR PROCESSING : 
C*          FILE OPEN AND END-OF-FILE CHECKING
C* 
C*     LANGUAGE AND COMPILER : 
C*          ANSI FORTRAN 77
C* 
C*     VERSION AND DATE : 
C*          VERSION I.0     12/26/84
C* 
C*     CHANGE HISTORY : 
C*          12/26/84     INITIAL VERSION 
C* 
C***********************************************************************
C* 
      PARAMETER (MXCHR=12)
      COMMON / STORE  / FUNNAM(50), SUBNAM(400), CALNAM(400), 
     $  NARGS(400), NARGC(400), NUMS, NUMF, NUMC, SAVE
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / LITTLE / NSUB, SAVNAM
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      LOGICAL SAVE
      CHARACTER *20 SAVNAM
      CHARACTER *(MXCHR) FUNNAM, CALNAM, SUBNAM 
C
      OPEN ( UNIT=NSAVE, STATUS='OLD', FILE=SAVNAM,
     $  FORM='UNFORMATTED', ERR=1000 )
      READ ( NSAVE, END=1000 ) NUMS, NUMF, NUMC
      DO 100 I = 1, NUMS
         READ ( NSAVE ) SUBNAM(I), NARGS(I)
100      CONTINUE
      DO 200 I = 1, NUMF
         READ ( NSAVE ) FUNNAM(I)
200      CONTINUE
      DO 300 I = 1, NUMC
         READ ( NSAVE ) CALNAM(I), NARGC(I)
300      CONTINUE
      CLOSE ( UNIT=NSAVE )
      RETURN
1000  WRITE ( NPRINT, 900 )
      NERROR = NERROR + 1
      RETURN
900   FORMAT (///,'  ******* UNABLE TO OPEN RESTORE FILE.')
      END
C
C---END RESTR
C
      SUBROUTINE CATEG
C* 
C*                  ******************************* 
C*                  ******************************* 
C*                  **                           ** 
C*                  **           CATEG           ** 
C*                  **                           ** 
C*                  ******************************* 
C*                  ******************************* 
C* 
C*     SUBPROGRAM : 
C*          CATEGORIZE
C* 
C*     AUTHOR : 
C*          ART RAGOSTA 
C*          MS 207-5 
C*          AMES RESEARCH CENTER 
C*          MOFFETT FIELD, CALIF 94035 
C*          (415)965-5578 
C* 
C*     PURPOSE : 
C*          CATEGORIZE THIS STATEMENT
C* 
C*     METHODOLOGY : 
C*          SINCE BLANKS ARE GONE, CHECK FIRST FIELD FOR 'CALL','IF(',ETC
C* 
C*     COMMON BLOCKS : 
C*          SWITCH, STYPE, STATMT
C* 
C*     SUBPROGRAM REFERENCES : 
C*          INDEX, FASSUR
C* 
C*     LANGUAGE AND COMPILER : 
C*          ANSI FORTRAN 77
C* 
C*     VERSION AND DATE : 
C*          VERSION II.0     01/24/84
C* 
C*     CHANGE HISTORY : 
C*          06/14/90     ADDED VAX SPEC STATEMENTS BYTE, UNION, MAP,
C*                         STRUCTURE AND RECORD
C*          09/15/86     MODIFIED TO REMOVE CHARACTER STRINGS FROM
C*                         STATEMENT BEING CATEGORIZED
C*          01/24/84     CONVERTED TO VAX
C*          10/13/83     INITIAL VERSION 
C* 
C***********************************************************************
C* 
      PARAMETER (MAXSTM=3000,NSPEC=14,NVSPEC=10)
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / STYPE / TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $   TYPECE, TYPER, TYPEND, SPSTM
      COMMON / STATMT / STMT, EOF, CLABEL
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      LOGICAL TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $        TYPECE, TYPER, TYPEND, SPSTM
      LOGICAL EOF
      LOGICAL FASSUR
      CHARACTER *5 CLABEL
      CHARACTER *6 SPEC(NSPEC)
      CHARACTER *8 VSPEC(NVSPEC)
      CHARACTER *(MAXSTM) STMT
      CHARACTER *(MAXSTM) WORK
      DATA SPEC/      
     $ 'CHARAC', 'COMMON', 'COMPLE', 'DIMENS', 'DOUBLE', 
     $ 'EQUIVA', 'EXTERN', 'IMPLIC', 'INCLUD', 'INTEGE', 
     $ 'INTRIN', 'LOGICA', 'REAL  ', 'SAVE  '/
      DATA VSPEC/
     $ 'BYTE    ', 'DEFINEFI', 'ENDMAP  ', 'ENDSTRUC', 'ENDUNION',
     $ 'MAP     ', 'NAMELIST', 'RECORD  ', 'STRUCTUR',
     $ 'UNION   '/
C     
      SPSTM  = .FALSE.
      TYPEP  = .FALSE.
      TYPES  = .FALSE.
      TYPEC  = .FALSE.
      TYPEF  = .FALSE.
      TYPER  = .FALSE.
      TYPEE  = .FALSE.
      TYPEST = .FALSE.
      TYPECE = .FALSE.
      TYPEND = .FALSE.
C
C --- COPY STMT INTO WORK, REMOVING ALL CHARACTER STRINGS
C
      CALL STRPSTM (STMT, LENST, WORK, IPTR)
C
C --- CATEGORIZE THE STATEMENT
C
      IF (INDEX(WORK,'FUNCTION') .NE. 0) THEN
         TYPEF = FASSUR(WORK)
      ELSE IF (WORK(1:4) .EQ. 'DATA') THEN
         ISL = INDEX(WORK,'/')
         IEQ = INDEX(WORK,'=')
         IF (IEQ .LT. ISL) SPSTM = .TRUE.
      ELSE IF ((WORK(1:8) .EQ. 'CALLEXIT').OR.
     $         (INDEX(WORK,')CALLEXIT') .NE. 0)) THEN
          TYPECE = .TRUE.
      ELSE IF (((WORK(1:4) .EQ. 'CALL') .AND. (INDEX(WORK,'=') .EQ. 0)) 
     $  .OR.((WORK(1:3) .EQ. 'IF(')) .AND. (INDEX(WORK,')CALL') .NE. 0))
     $    THEN
         TYPEC = .TRUE.
      ELSEIF (WORK(1:10) .EQ. 'SUBROUTINE') THEN
         TYPES = .TRUE.
      ELSEIF ((WORK(1:5) .EQ. 'ENTRY') .AND. 
     $        (INDEX(WORK,'=') .EQ. 0)) THEN
         TYPEE = .TRUE.
      ELSEIF (WORK(1:7) .EQ. 'PROGRAM') THEN
         TYPEP = .TRUE.
      ELSEIF ((WORK(1:7) .EQ. 'RETURN ') .OR. 
     $       ((WORK(1:3) .EQ. 'IF(') .AND. 
     $        (INDEX(WORK,')RETURN ') .NE. 0))) THEN
         TYPER = .TRUE.
      ELSEIF ( (WORK(1:5) .EQ. 'STOP ') .OR. 
     $         (INDEX(WORK,')STOP ') .NE. 0) ) THEN
         TYPEST = .TRUE.
      ELSEIF (WORK(1:4) .EQ. 'END ') THEN
         TYPEND = .TRUE.
      ELSE
         DO 20 I = 1,NSPEC
            IF (((INDEX(WORK(1:LENST),SPEC(I)(1:LENGTH(SPEC(I)))) 
     $        .NE. 0) .AND. (INDEX (WORK,'=') .EQ. 0)) 
     $        .OR. (WORK(1:10) .EQ. 'PARAMETER(' ) ) THEN
               SPSTM = .TRUE.
               RETURN
            ENDIF
20       CONTINUE
         DO 30 I = 1,NVSPEC
            IF ((INDEX(WORK(1:LENST),VSPEC(I)(1:LENGTH(VSPEC(I)))) 
     $        .NE. 0) .AND. (INDEX (WORK,'=') .EQ. 0)) THEN
               SPSTM = .TRUE.
               RETURN
            ENDIF
30       CONTINUE
      ENDIF
      RETURN
      END
C
C---END CATEG
C 
      SUBROUTINE NAMEX ( NAME, ONLY )
C* 
C*                  ******************************* 
C*                  ******************************* 
C*                  **                           ** 
C*                  **          NAMEX            ** 
C*                  **                           ** 
C*                  ******************************* 
C*                  ******************************* 
C* 
C*     SUBPROGRAM : 
C*          NAME EXTRACTION 
C* 
C*     AUTHOR : 
C*          ART RAGOSTA 
C*          MS 207-5 
C*          AMES RESEARCH CENTER 
C*          MOFFETT FIELD, CALIF 94035 
C*          (415)965-5578 
C* 
C*     PURPOSE : 
C*          EXTRACT THE SUBPROGRAM NAME FROM THE STATEMENT. 
C* 
C*     OUTPUT ARGUMENTS : 
C*          NAME  - THE NAME OF THE SUBPROGRAM
C* 
C*     COMMON BLOCKS : 
C*          SWITCH, STYPE, STATMT
C* 
C*     FILE REFERENCES : 
C*          NPRINT
C* 
C*     SUBPROGRAM REFERENCES : 
C*          INDEX, PUTSTM
C* 
C*     LANGUAGE AND COMPILER : 
C*          ANSI FORTRAN 77
C* 
C*     VERSION AND DATE : 
C*          VERSION II.0     01/24/84
C* 
C*     CHANGE HISTORY : 
C*          01/24/84     CONVERTED TO VAX
C*          10/13/83     INITIAL VERSION 
C* 
C***********************************************************************
C* 
      PARAMETER (MAXSTM=3000,MXCHR=12)
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / STYPE / TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $   TYPECE, TYPER, TYPEND, SPSTM
      COMMON / STATMT / STMT, EOF, CLABEL
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      LOGICAL TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $        TYPECE, TYPER, TYPEND, SPSTM
      LOGICAL EOF, ONLY
      CHARACTER *5 CLABEL
      CHARACTER *(MXCHR) NAME
      CHARACTER *(MAXSTM) STMT
C 
C --- START EXTRACTING NAME THE FIRST CHARACTER AFTER THE KEYWORD
C
      IF (TYPES) THEN
         NSTART = 11
      ELSEIF (TYPEE) THEN
         NSTART = 6
      ELSEIF (TYPEC) THEN
         NSTART = INDEX(STMT,'CALL') + 4
      ELSEIF (TYPEP) THEN
         NSTART = 8
      ELSE
         NSTART = INDEX(STMT,'FUNCTION') + 8
      ENDIF
C
C --- STOP SEARCHING AFTER 10 CHARACTERS, WHEN A '(' IS FOUND, OR AT THE END
C ---  OF THE STATEMENT; WHICHEVER COMES FIRST
C
      NPLUS = NSTART+MXCHR
      IF (NPLUS .GT. LENST)NPLUS = LENST
      DO 10 I = NSTART,NPLUS
         IF (STMT(I:I) .EQ. '(')GO TO 20
   10 CONTINUE
      I = NPLUS+1
   20 I = I-1
      NAME = STMT(NSTART:I)
      IF ( .NOT. ONLY ) THEN
         IF ( TYPEC ) THEN
            IF ( NOUT .EQ. 1 ) THEN
               WRITE ( NPRINT, 900 )NAME
            ELSE IF ( NOUT .EQ. 2 ) THEN
               CALL PUTSTM ( NPRINT, CLABEL, STMT )
            ENDIF
         ELSEIF ( TYPES .OR. TYPEE ) THEN
            IF ( NOUT .EQ. 2 ) THEN
               CALL PUTSTM ( NPRINT, CLABEL, STMT )
            ELSE
               WRITE ( NPRINT, 910 )NAME
            ENDIF
         ELSEIF ( TYPEP ) THEN
            WRITE ( NPRINT, 915 )NAME
         ELSE
            WRITE ( NPRINT, 920 )NAME
         ENDIF
      ENDIF
      RETURN 
900   FORMAT ('      CALL ',A)
910   FORMAT (//,' SUBROUTINE ',A)
915   FORMAT (//,' PROGRAM ',A)
920   FORMAT (//,' FUNCTION ',A)
      END 
C
C---END NAMEX
C
      SUBROUTINE ARGEX ( NUMBER )
C* 
C*                  ******************************* 
C*                  ******************************* 
C*                  **                           ** 
C*                  **          ARGEX            ** 
C*                  **                           ** 
C*                  ******************************* 
C*                  ******************************* 
C* 
C*     SUBPROGRAM : 
C*          ARGUMENT EXTRACTION 
C* 
C*     AUTHOR : 
C*          ART RAGOSTA 
C*          MS 207-5 
C*          AMES RESEARCH CENTER 
C*          MOFFETT FIELD, CALIF 94035 
C*          (415)965-5578 
C* 
C*     PURPOSE : 
C*          EXTRACT THE NUMBER OF ARGUMENTS FROM THE STATEMENT. 
C* 
C*     METHODOLOGY : 
C*          COUNT COMMAS WHICH ARE NOT INSIDE PARENTHESES AND 
C*          ADD ONE. 
C* 
C*     OUTPUT ARGUMENTS : 
C*          NUMBER - THE NUMBER OF ARGUMENTS
C* 
C*     COMMON BLOCKS : 
C*          SWITCH, STYPE, STATMT
C* 
C*     FILE REFERENCES : 
C*          NPRINT
C* 
C*     SUBPROGRAM REFERENCES : 
C*          INDEX
C* 
C*     ERROR PROCESSING :      
C*          CHECK FOR BALANCED PARENS IN ARGUMENT LIST
C* 
C*     LANGUAGE AND COMPILER : 
C*          ANSI FORTRAN 77
C* 
C*     VERSION AND DATE : 
C*          VERSION II.2     JUNE 4 1985
C* 
C*     CHANGE HISTORY : 
C*          06/04/85     FIXED BUG IN SUBSCRIPTED ARGUMENTS
C*          04/22/85     LITERAL STRING HANDLING IMPROVED
C*          01/24/84     CONVERTED TO VAX
C*          10/13/83     INITIAL VERSION 
C* 
C***********************************************************************
C* 
      PARAMETER(MAXSTM=3000)
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / STYPE / TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $   TYPECE, TYPER, TYPEND, SPSTM
      COMMON / STATMT / STMT, EOF, CLABEL
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      LOGICAL TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $        TYPECE, TYPER, TYPEND, SPSTM
      LOGICAL EOF
      CHARACTER *(MAXSTM) STMT
      CHARACTER *5 CLABEL
C     
      NUMBER = 0
C
C --- START COUNTING ARGUMENTS AT THE '(' UNLESS THERE IS NO ARGUMENT LIST
C
      I = INDEX(STMT,'(')
      IF (I .EQ. 0) RETURN
      IF ( TYPEC ) THEN
         IF (STMT(1:4) .NE. 'CALL')THEN
            I = INDEX(STMT,')CALL') + 5
5           I = I + 1
            IF (STMT(I:I) .EQ. '(')GO TO 7
            IF (I .LT. LENST)GO TO 5
            RETURN
         ENDIF
      ENDIF
C
C --- THE NUMBER OF ARGUMENTS IS THE NUMBER OF COMMAS PLUS ONE
C
7     NUMBER = 1
C
C --- DON'T COUNT COMMAS IN ARRAY INDICES
C
      NEST = 0
10    I = I+1
      IF (I .GT. LENST) THEN
         WRITE (NPRINT, 900) NSTMTS
         NERROR = NERROR+1
         RETURN
      ENDIF
C
C --- IF WE ARE NOT NESTED AND WE FIND A COMMA, INCREMENT NUMBER OF ARGUMENTS
C --- IF WE FIND A '(' INCREMENT NEST LEVEL
C --- IF WE FIND A ')' DECREMENT NEST LEVEL UNLESS NEST LEVEL IS ALREADY 0
C ---    IN WHICH CASE WE FALL THROUGH TO THE RETURN STATEMENT
C
      IF (STMT(I:I) .EQ. ','  .AND.  NEST .EQ. 0)NUMBER = NUMBER+1
      IF (STMT(I:I) .EQ. '(') THEN
         NEST = NEST+1
      ELSE IF (STMT(I:I) .EQ. ')') THEN
         IF (NEST .GT. 0) THEN
            NEST = NEST-1
         ELSE
C
C ----- ALL ARGUMENTS HAVE BEEN FOUND... EXIT ROUTINE
C
            GO TO 30
         ENDIF
C
C --- CHECK FOR A LITERAL IN THE ARGUMENT LIST
C
      ELSE IF (STMT(I:I) .EQ. '''') THEN
20       I = I + 1
         IF (I .GT. LENST ) THEN
            WRITE (NPRINT, 900) NSTMTS
            NERROR = NERROR+1
            RETURN
         ENDIF
C
C ----- CHECK FOR CLOSE QUOTE
C
         IF (STMT(I:I) .EQ. '''') THEN
C
C -------- MAKE SURE IT ISN'T AN EMBEDDED QUOTE
C
            IF (STMT(I+1:I+1) .EQ. '''') THEN
               I = I + 1 
               GO TO 20
            ENDIF
         ELSE
            GO TO 20
         ENDIF
C
C --- ALL OTHER CHARACTERS ARE SKIPPED
C
      ENDIF
      GO TO 10
C
30    IF ( NOUT .EQ. 2 ) WRITE (NPRINT, 910)NUMBER
      RETURN 
900   FORMAT (/,' ***** ERROR AT STMT NUMBER ',I,/
     $          '        UNBALANCED PARENTHESES ENCOUNTERED'/)
910   FORMAT ('   NUMBER OF ARGUMENTS= ',I3)
      END 
C
C---END ARGEX
C
      SUBROUTINE CHECK ( NAME, NUMBER )
C* 
C*                  ******************************* 
C*                  ******************************* 
C*                  **                           ** 
C*                  **          CHECK            ** 
C*                  **                           ** 
C*                  ******************************* 
C*                  ******************************* 
C* 
C*     SUBPROGRAM : 
C*          CHECK 
C* 
C*     AUTHOR : 
C*          ART RAGOSTA 
C*          MS 207-5 
C*          AMES RESEARCH CENTER 
C*          MOFFETT FIELD, CALIF 94035 
C*          (415)965-5578 
C* 
C*     PURPOSE : 
C*          CHECK TO SEE IF THIS NAME IS KNOWN; IF IT 
C*          IS, COMPARE THE NUMBER OF ARGUMENTS. 
C* 
C*     INPUT ARGUMENTS : 
C*          NAME  - THE NAME OF THE SUBPROGRAM TO CHECK
C*          NUMBER- THE NUMBER OF ARGUMENTS FOUND
C* 
C*     COMMON BLOCKS : 
C*          STORE, SWITCH, STYPE, CHARTX, LITTLE, MERLIB
C* 
C*     FILE REFERENCES : 
C*          NPRINT - WRITE ERROR MESSAGES
C* 
C*     SUBPROGRAM REFERENCES : 
C*          PUTSTM
C* 
C*     ERROR PROCESSING : 
C*          DON'T EXCEED DIMENSIONS WHEN COUNTING NAMES IN CALL STATEMENTS
C*          DON'T EXCEED DIMENSIONS WHEN COUNTING NAMES IN SUBROUTINE STMTS
C*          CHECK SUBROUTINE NAMES FOR DUPLICATE ENTRIES
C* 
C*     LANGUAGE AND COMPILER : 
C*          ANSI FORTRAN 77
C* 
C*     VERSION AND DATE : 
C*          VERSION II.1           MARCH 12, 1984
C* 
C*     CHANGE HISTORY : 
C*          03/24/87     MERLIB CHECKING ADDED
C*          03/12/84     CALLS CROSS-REFERENCE ADDED
C*          01/24/84     CONVERTED TO VAX
C*          10/13/83     INITIAL VERSION 
C* 
C***********************************************************************
C* 
      PARAMETER (MAXSTM=3000,MXMRLB=200,MXCHR=12)
      COMMON / MERLIB / MNAME(MXMRLB), NARGM(MXMRLB), NUMRLB
      COMMON / STORE  / FUNNAM(50), SUBNAM(400), CALNAM(400), 
     $  NARGS(400), NARGC(400), NUMS, NUMF, NUMC, SAVE
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / STYPE / TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $   TYPECE, TYPER, TYPEND, SPSTM
      COMMON / CHARTX / CHRT(200), OPST
      COMMON / LITTLE / NSUB, SAVNAM
      COMMON / STATMT / STMT, EOF, CLABEL
      LOGICAL SAVE
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX, EOF
      LOGICAL TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $        TYPECE, TYPER, TYPEND, SPSTM
      CHARACTER *5 CLABEL
      CHARACTER *20 SAVNAM
      CHARACTER *(MAXSTM) STMT
      CHARACTER *(MXCHR) FUNNAM, CALNAM, SUBNAM, NAME, MNAME
      CHARACTER *200 CHRT
      CHARACTER *132 OPST
C
C --- IF IT IS A CALL STATEMENT; CHECK PREVIOUS CALL STATEMENTS.
C ---  IF NONE ARE FOUND, CHECK PREVIOUS SUBROUTINE STATEMENTS.
C ---  THERE IS NO NEED TO CHECK SUBROUTINE STATEMENTS IF A PREVIOUS
C ---  CALL STATEMENT IS FOUND.
C 
      IF ( TYPEC ) THEN
         DO 10 I = 1, NUMC
            IF ( NAME .EQ. CALNAM(I)) THEN
               IF ( MAP .AND. I.LE.200) CHRT(NSUB)(I:I) = 'X'
               IF (NUMBER .NE. NARGC(I)) THEN
                  WRITE ( NPRINT, 920 )NSTMTS, NAME, NUMBER, NARGC(I)
                  NERROR = NERROR + 1
                  IF (NOUT .EQ. 2) CALL PUTSTM ( NPRINT, CLABEL, STMT )
               ENDIF
               RETURN
            ENDIF
10       CONTINUE
C
C --- NAME WAS NOT FOUND... ADD IT TO LIST
C
         IF ( NUMC .GT. 400 ) THEN
            WRITE ( NPRINT, 900 ) NSTMTS
            CALL PUTSTM ( NPRINT, CLABEL, STMT )
            RETURN
         ENDIF
         NUMC = NUMC + 1
         CALNAM(NUMC) = NAME
         NARGC(NUMC) = NUMBER
         IF ( MAP .AND. NUMC.LE.200) CHRT(NSUB)(NUMC:NUMC) = 'X'
C
C --- SINCE THIS WAS A NEW NAME, COMPARE IT TO THE NAMES FOUND IN SUBROUTINE
C ---  STATEMENTS.
C
         DO 20 I = 1, NUMS
            IF (NAME .EQ. SUBNAM(I)) THEN
               IF (NUMBER .NE. NARGS(I)) THEN
                  WRITE ( NPRINT, 910 )NSTMTS, NAME, NUMBER, NARGS(I)
                  NERROR = NERROR + 1
                  IF (NOUT .EQ. 2) CALL PUTSTM ( NPRINT, CLABEL, STMT)
                ENDIF
                RETURN
            ENDIF
20       CONTINUE
C
C --- NAME NOT FOUND IN NAMES OF SUBROUTINE STATEMENTS...
C --- MAYBE IT'S A MERLIB ROUTINE ?
C
         DO 30 IM = 1, NUMRLB
            IF (NAME .EQ. MNAME(IM)) THEN
               IF (NUMBER .NE. NARGM(IM)) THEN
                  WRITE (NPRINT,915) NSTMTS, MNAME(IM), 
     $                               NARGM(IM), NUMBER
                  IF (NOUT .EQ. 2) CALL PUTSTM (NPRINT,CLABEL, STMT)
               ENDIF
               RETURN
            ENDIF
30       CONTINUE
         RETURN
C
C --- FOR SUBROUTINE STATEMENTS... COMPARE TO ANY PREVIOUS CALL STATEMENTS
C
      ELSEIF ( TYPES .OR. TYPEE ) THEN
         DO 50 I = 1, NUMS
            IF ( NAME .EQ. SUBNAM(I)) THEN
C
C --- DUPLICATE SUBROUTINE NAMES IS NOT SPECIFICALLY AN ERROR, BUT DUMB.
C ---  CONTINUE TO USE FIRST DEFINITION.
C
               WRITE ( NPRINT, 950 ) NSTMTS
               NERROR = NERROR + 1
               IF (NOUT .EQ. 2) CALL PUTSTM ( NPRINT,CLABEL,STMT )
               RETURN
            ENDIF
50       CONTINUE                     
C
C --- ADD NEW SUBROUTINE NAME
C
         IF ( NUMS .GT. 400 ) THEN
            WRITE ( NPRINT, 930 ) NSTMTS
            CALL PUTSTM ( NPRINT,CLABEL,STMT )
            RETURN
         ENDIF
         NUMS = NUMS + 1
         NSUB = NUMS
         SUBNAM(NUMS) = NAME
         NARGS(NUMS)  = NUMBER
         CHRT(NUMS)   = ' '
C
C --- CHECK FOR POSSIBLE MERLIB ROUTINE
C
         DO 55 IM = 1,NUMRLB
            IF (NAME .EQ. MNAME(IM)) THEN
                WRITE(NPRINT,925)
                GO TO 57
            ENDIF
55       CONTINUE
C
C --- COMPARE NUMBER OF ARGUMENTS TO NUMBER IN CALL STATEMENTS.
C
57       DO 60 I = 1, NUMC
            IF (NAME .EQ. CALNAM(I)) GO TO 70
60       CONTINUE
         RETURN
70       IF (NUMBER .NE. NARGC(I)) THEN
            WRITE ( NPRINT, 940 )NSTMTS, NAME, NUMBER, NARGC(I)
            NERROR = NERROR + 1
            IF (NOUT .EQ. 2) CALL PUTSTM ( NPRINT,CLABEL,STMT )
         ENDIF
      ELSEIF ( TYPEP ) THEN
C
C --- ADD PROGRAM NAME
C
         SUBNAM(1) = NAME
         NARGS(1)  = 0
         NSUB      = 1
      ELSE
         DO 80 I = 1, NUMF
            IF ( NAME .EQ. FUNNAM(I)) THEN
C
C --- DUPLICATE FUNCTION NAME
C
               WRITE ( NPRINT, 960 ) NSTMTS
               NERROR = NERROR + 1
               IF (NOUT .EQ. 2) CALL PUTSTM ( NPRINT, CLABEL, STMT )
               RETURN
            ENDIF
80       CONTINUE
C
C --- ADD NEW FUNCTION NAME
C
         IF ( NUMF .GT. 400 ) THEN
            WRITE ( NPRINT, 935 ) NSTMTS
            CALL PUTSTM ( NPRINT, CLABEL, STMT )
            RETURN
         ENDIF
         NUMF = NUMF + 1
         FUNNAM(NUMF) = NAME
      ENDIF
      RETURN 
900   FORMAT 
     $ (/ '******* ERROR AT STMT NUMBER ',I6,
     $   ' ,TOO MANY UNIQUE NAMES IN CALL STATEMENTS...',
     $ /,' *******        CALL STATEMENT NOT ADDED TO LIST.'/)
910   FORMAT
     $ (/ '******* ERROR AT STMT NUMBER ',I6,
     $   ' , DISAGREEMENT BETWEEN THIS CALL AND SUBROUTINE',
     $ /,' *******        FOR SUBPROGRAM ',A,
     $ /,' *******        THIS CALL STATEMENT  = ',I3,
     $ /,' *******        SUBROUTINE STATEMENT = ',I3,/)
915   FORMAT
     $ (/ '   **** NOTICE AT STMT NUMBER ',I6,/,
     $    '        THE MERLIN SYSTEM LIBRARY ROUTINE ',A,
     $ /, '        TAKES ',I3,' ARGUMENTS',
     $ /, '        THIS CALL STATEMENT = ',I3,/)
920   FORMAT
     $ (/ '******* ERROR AT STMT NUMBER ',I6,
     $   ' , DISAGREEMENT BETWEEN THIS CALL AND PREVIOUS',
     $ /,' *******        FOR SUBPROGRAM ',A,
     $ /,' *******        THIS CALL STATEMENT     = ',I3,
     $ /,' *******        PREVIOUS CALL STATEMENT = ',I3,/)
925   FORMAT(/ '   **** NOTICE - THE MERLIN SYSTEM LIBRARY MERLIB',
     $       /,'                 HAS A ROUTINE WITH THIS NAME',/)
930   FORMAT 
     $ (/ '******* ERROR AT STMT NUMBER ',I6,
     $   ' , TOO MANY UNIQUE NAMES IN SUBR. STATEMENTS...',
     $ /,' *******        SUBROUTINE NAME NOT ADDED TO LIST.',/)
935   FORMAT
     $ (/ '******* ERROR AT STMT NUMBER ',I6,
     $   ' , TOO MANY UNIQUE NAMES IN FUNC. STATEMENTS...',
     $ /,' *******        FUNCTION NAME NOT ADDED TO LIST.',/)
940   FORMAT
     $ (/ '******* ERROR AT STMT NUMBER ',I6,
     $   ' , DISAGREEMENT BETWEEN SUBROUTINE AND CALL',
     $ /,' *******        FOR SUBPROGRAM ',A,
     $ /,' *******        SUBROUTINE STATEMENT    = ',I3,
     $ /,' *******        PREVIOUS CALL STATEMENT = ',I3,/)
950   FORMAT
     $ (/ '******* ERROR AT STMT NUMBER ',I6,
     $   ' , DUPLICATE SUBROUTINE NAME.',/)
960   FORMAT
     $ (/ '******* ERROR AT STMT NUMBER ',I6,
     $   ' , DUPLICATE FUNCTION NAME.',/)
      END 
C
C---END CHECK
C
      SUBROUTINE XRETUR
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          XRETUR           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          RETURN STATEMENT
C*
C*     AUTHOR :
C*          ART RAGOSTA
C*          MS 207-5
C*          AMES RESEARCH CENTER
C*          MOFFETT FIELD, CALIF  94035
C*          (415)965-5578
C*
C*     PURPOSE :
C*          THIS SUBPROGRAM DOES THE PROCESSING REQUIRED
C*          WHEN A RETURN STATEMENT IS ENCOUNTERED IN THE
C*          FORTRAN CODE.
C*
C*     COMMON BLOCKS :
C*          SWITCH, MISC, STATMT
C*
C*     FILE REFERENCES :
C*          NCODE - INSTRUMENTED SOURCE CODE OUTPUT
C*
C*     SUBPROGRAM REFERENCES :
C*         INDEX
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     10/04/83
C*
C*     CHANGE HISTORY :
C*          09/15/86     MODIFIED TO PROCESS FORTRAN STATEMENTS INSTEAD
C*                         OF CARDS
C*          10/04/83     INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MAXSTM=3000)
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / MISC   / NUM, NUNIT, PUTSTP, PUTRET
      COMMON / STATMT / STMT, EOF, CLABEL
      CHARACTER *(MAXSTM) STMT
      CHARACTER *5 CLABEL, START
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      LOGICAL PUTSTP, PUTRET
      LOGICAL EOF
C       
      I = INDEX(STMT,'RETURN')
      WRITE (START,900) ISTART + 1
      IF (I .GT. 1) THEN
         STMT  = STMT(1:I-1) // 'GO TO '//START
         LENST = LENST + 5
      ELSE
         STMT  = 'GO TO '//START
         LENST = 11
      ENDIF
C
C --- SIGNAL 'XEND' THAT A RETURN STATEMENT WAS REPLACED
C
      PUTRET = .TRUE.
      RETURN
900   FORMAT (I5)
      END
C
C---END XRETUR
C
      SUBROUTINE SUBPRO ( ITYPE )
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          SUBPRO           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          SUBPROGRAM
C*
C*     AUTHOR :
C*          ART RAGOSTA
C*          MS 207-5
C*          AMES RESEARCH CENTER
C*          MOFFETT FIELD, CALIF  94035
C*          (415)965-5578
C*
C*     PURPOSE :
C*          THIS SUBPROGRAM DOES THE PROCESSING REQUIRED
C*          WHEN A NEW SUBPROGRAM IS ENCOUNTERED IN THE
C*          FORTRAN CODE.
C*
C*     INPUT ARGUMENTS :
C*          ITYP -  =1 FOR SUBROUTINE
C*                  =2 FOR FUNCTION
C*                  =3 FOR ENTRY
C*
C*     COMMON BLOCKS :
C*          SWITCH, STATMT, MISC, MATCH
C*
C*     FILE REFERENCES :
C*          NCODE - INSTRUMENTED SOURCE CODE OUTPUT
C*
C*     SUBPROGRAM REFERENCES :
C*          NAMEX, PUTSTM, GETSTM, INDEX
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     10/04/83
C*
C*     CHANGE HISTORY :
C*          09/15/86     MODIFIED TO PROCESS FORTRAN STATEMENTS INSTEAD
C*                         OF CARDS
C*          10/04/83     INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (MAXSTM=3000,MXCHR=12)
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / STYPE / TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $   TYPECE, TYPER, TYPEND, SPSTM
      COMMON / STATMT / STMT, EOF, CLABEL
      COMMON / MISC   / NUM, NUNIT, PUTSTP, PUTRET
      COMMON / MATCH  / NAMES(500), NNAMES
      CHARACTER *(MAXSTM) STMT
      CHARACTER *5 CLABEL
      CHARACTER *8 NAMES
      CHARACTER *(MXCHR) NAME
      LOGICAL TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $        TYPECE, TYPER, TYPEND, SPSTM
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      LOGICAL PUTSTP, PUTRET
      LOGICAL EOF
      LOGICAL ONLY
C
      IF (ITYPE .EQ. 3) THEN
         WRITE ( NCODE, 900 ) ISTART
         CALL PUTSTM ( NCODE, CLABEL, STMT )
         WRITE ( NCODE, 920 ) NUM
         WRITE ( NCODE, 940 ) ISTART
         IF (EOF) CALL ENDUP
         CALL GETSTM (NREAD, STMT, LENST, CLABEL, EOF)
         IF (LENST .GT. MAXSTM) GO TO 100
         NSTMTS = NSTMTS + 1
         RETURN
      ENDIF
C
C --- ENTRIES ARE ADDED TO THE SUBPROGRAM STATISTICS...
C
      ONLY = .TRUE.
      CALL NAMEX (NAME,ONLY)
      IF (NNAMES .EQ. 500) THEN
         WRITE(NPRINT,930)
         RETURN
      ENDIF
      NNAMES = NNAMES + 1
      NAMES(NNAMES) = NAME
      NUM = NNAMES
      PUTSTP = .FALSE.
      PUTRET = .FALSE.
      CALL PUTSTM ( NCODE, CLABEL, STMT )
      IF (EOF) CALL ENDUP
      CALL GETSTM (NREAD, STMT, LENST, CLABEL, EOF)
      IF (LENST .GT. MAXSTM) GO TO 100
      NSTMTS = NSTMTS + 1
C
C --- SKIP SPECIFICATION STATEMENTS
C
30    CALL CATEG
      IF (SPSTM) THEN
         CALL PUTSTM ( NCODE, CLABEL, STMT )
         IF (EOF) CALL ENDUP
         CALL GETSTM (NREAD, STMT, LENST, CLABEL, EOF)
         IF (LENST .GT. MAXSTM) GO TO 100
         NSTMTS = NSTMTS + 1
         GO TO 30
      ENDIF
C
C --- FIRST EXECUTABLE STATEMENT OF SUBPROGRAM FOUND
C
      WRITE ( NCODE, 920 ) NUM
      RETURN
100   WRITE (NPRINT,910) MAXSTM, STMT(1:72)
      CALL ENDUP
900   FORMAT ('      GO TO ',I5 )
910   FORMAT (/
     $ ' ***** FATAL ERROR !',/
     $ ' STATEMENT LENGTH EXCEEDS PROGRAM DIMENSION OF ',I4,/,
     $ ' FIRST 72 CHARACTERS OF OFFENDING STATEMENT: ',/,
     $ ' "',A72,'"',/,
     $ ' PREPROCESSOR TERMINATED.')
920   FORMAT ('      CALL Q1QIN (',I3,')' )
930   FORMAT
     $  (' ***** ERROR, MAXIMUM NUMBER OF SUBPROGRAM NAMES EXCEEDED.')
940   FORMAT (I5,' CONTINUE')
      END
C
C---END SUBPRO
C 
      SUBROUTINE XSTOP
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          XSTOP            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          STOP STATEMENT
C*
C*     AUTHOR :
C*          ART RAGOSTA
C*          MS 207-5
C*          AMES RESEARCH CENTER
C*          MOFFETT FIELD, CALIF  94035
C*          (415)965-5578
C*
C*     PURPOSE :
C*          THIS SUBPROGRAM DOES THE PROCESSING REQUIRED
C*          WHEN A STOP STATEMENT IS ENCOUNTERED IN THE
C*          FORTRAN CODE.
C*
C*     COMMON BLOCKS :
C*          SWITCH, MISC, STATMT
C*
C*     FILE REFERENCES :
C*          NCODE - INSTRUMENTED SOURCE CODE OUTPUT
C*
C*     SUBPROGRAM REFERENCES :
C*         INDEX
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     10/04/83
C*
C*     CHANGE HISTORY :
C*          09/15/86     MODIFIED TO PROCESS FORTRAN STATEMENTS INSTEAD
C*                         OF CARDS
C*          10/04/83     INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MAXSTM=3000)
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / STYPE / TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $   TYPECE, TYPER, TYPEND, SPSTM
      COMMON / MISC   / NUM, NUNIT, PUTSTP, PUTRET
      COMMON / STATMT / STMT, EOF, CLABEL
      CHARACTER *(MAXSTM) STMT
      CHARACTER *5 CLABEL, START
      LOGICAL TYPES, TYPEF, TYPEC, TYPEP, TYPEE, TYPEST,
     $        TYPECE, TYPER, TYPEND, SPSTM
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      LOGICAL PUTSTP, PUTRET
      LOGICAL EOF
C
      IF (TYPEST) THEN
C
C --- STOP STATEMENT
C
         I = INDEX(STMT,'STOP')
         IF (INDEX(STMT,'STOP''') .NE. 0) WRITE(NPRINT,900)
      ELSE
C
C --- CALL EXIT STATEMENT
C
         I = INDEX(STMT,'CALLEXIT')
         IF (INDEX(STMT,'CALLEXIT(') .NE. 0) WRITE(NPRINT,910)
      ENDIF
      WRITE (START,920) ISTART+2
      IF (I .GT. 1) THEN
         STMT  = STMT(1:I-1) // 'GO TO '//START
         LENST = (I-1) + 11
      ELSE
         STMT  = 'GO TO '//START
         LENST = 11
      ENDIF
C
C --- SIGNAL 'XEND' THAT A STOP STATEMENT WAS REPLACED
C
      PUTSTP = .TRUE.
      RETURN 
900   FORMAT
     $ (/' ** Warning, trailing STOP string deleted in BUGOUT.FOR!')
910   FORMAT
     $ (/' ** Warning, CALL EXIT with parameter deleted in BUGOUT.FOR!')
920   FORMAT (I5)
      END
C
C---END XSTOP
C
      SUBROUTINE XEND
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          XEND             **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          END STATEMENT
C*
C*     AUTHOR :
C*          ART RAGOSTA
C*          MS 207-5
C*          AMES RESEARCH CENTER
C*          MOFFETT FIELD, CALIF  94035
C*          (415)965-5578
C*
C*     PURPOSE :
C*          THIS SUBPROGRAM DOES THE PROCESSING REQUIRED
C*          WHEN AN END STATEMENT IS ENCOUNTERED IN THE
C*          FORTRAN CODE.
C*
C*     COMMON BLOCKS :
C*          MISC
C*
C*     FILE REFERENCES :
C*          NCODE - INSTRUMENTED SOURCE CODE OUTPUT
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION II.0     01/27/84
C*
C*     CHANGE HISTORY :
C*          01/27/84     VAX VERSION
C*          10/04/83     INITIAL VERSION
C*
C***********************************************************************
C*
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      COMMON / MISC   / NUM, NUNIT, PUTSTP, PUTRET
      LOGICAL PUTSTP, PUTRET
C
      IF ( PUTSTP ) THEN
         IF ( NUM .EQ. 1 ) THEN
            WRITE(NCODE,900) ISTART+2
         ELSE
            WRITE(NCODE,905) ISTART+2,NUM
         ENDIF
      ENDIF
      IF ( PUTRET ) WRITE(NCODE,910) ISTART+1, NUM
      PUTSTP = .FALSE.
      PUTRET = .FALSE.
      RETURN
900   FORMAT (I5,' CALL Q1QSUM',/,
     $        '      STOP')
905   FORMAT (I5,' CALL Q1QOUT(',I3,')',/,
     $        '      CALL Q1QSUM',/,
     $        '      STOP')
910   FORMAT (I5,' CALL Q1QOUT(',I3,')',/,
     $        '      RETURN' )
C920   FORMAT ('      DEBUG SUBCHK')
      END
C
C---END XEND
C
      SUBROUTINE FOROUT
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          FOROUT           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          FORTRAN OUTPUT
C*
C*     AUTHOR :
C*          ART RAGOSTA
C*          MS 219-3
C*          AMES RESEARCH CENTER
C*          MOFFETT FIELD, CALIF  94035
C*          (415) 604-5558
C*
C*     PURPOSE :
C*          THIS SUBPROGRAM OUTPUTS THE APPROPRIATE FORTRAN
C*          CODE IN LIGHT OF THE OPTIONS CHOSEN.
C*
C*     COMMON BLOCKS :
C*          SWITCH, MISC, MATCH
C*
C*     FILE REFERENCES :
C*          NCODE - OUTPUT OF RUN-TIME ROUTINES
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     CHANGE HISTORY :
c*          04/20/90     Fixed roundoff error, changed numcalls to I7
C*          10/04/83     INITIAL VERSION
C*
C***********************************************************************
C*
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / MISC   / NUM, NUNIT, PUTSTP, PUTRET
      COMMON / MATCH  / NAMES(500), NNAMES
      CHARACTER *72 LINE
      CHARACTER *8 NAMES
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      LOGICAL PUTSTP, PUTRET
C
      IF ( NUM .EQ. 0 )NUM = 1
      WRITE ( NCODE, 900 )NUM, NUM, NUM, NUNIT
      IF ( LTIME ) WRITE ( NCODE, 910 )
      WRITE ( NCODE, 920 )NUM, NUM, NUM
      IF ( LTIME ) WRITE ( NCODE, 930 )
      IF ( LTRACE ) WRITE ( NCODE, 940 )
      WRITE ( NCODE, 950 )NUM, NUM, NUM
      IF ( LTIME ) WRITE ( NCODE, 960 )
      WRITE ( NCODE, 970 )
      IF ( LTRACE ) WRITE ( NCODE, 980 )
      WRITE ( NCODE, 990 )NUM, NUM, NUM
      IF ( LTIME ) WRITE ( NCODE, 9000 )
      WRITE ( NCODE, 9010 )
      IF ( LTIME ) WRITE ( NCODE, 9020 )NUM, NUM
      WRITE ( NCODE, 9030 )NUM, NUM, NUM, NUM
C
C --- BUILD DATA STATEMENT FOR NAMES
C
      NPART = MOD(NNAMES,5)
      NFULL = (NNAMES - NPART)/5
      NCOUNT = 1
      IF (NFULL .GE. 1) THEN
         DO 100 I = 1, NFULL
            LINE = '$'
            K = 3
            DO 50 J = 1,5
               LINE(K:K+11) = ''''//NAMES(NCOUNT)//''','
               K = K + 11
               NCOUNT = NCOUNT + 1
50             CONTINUE
            IF ((I .EQ. NFULL) .AND. (NPART .EQ. 0))LINE(K-1:K-1) = '/'
            WRITE(NCODE,9040)LINE
100         CONTINUE
      ENDIF
C
C --- CONSTRUCT PARTIAL LINE
C
      IF (NPART .GT. 0) THEN
         LINE = '$'
         K = 3
         DO 200 I = 1, NPART
            LINE(K:K+11) = '''' // NAMES(NCOUNT) // ''','
            K = K + 11
            NCOUNT = NCOUNT + 1
200         CONTINUE
         LINE(K-1:K-1) = '/'
         WRITE(NCODE,9040)LINE
      ENDIF
      WRITE(NCODE,9050)
      RETURN
900   FORMAT ('      SUBROUTINE Q1QINIT',/,
     $ '      COMMON / Q1QCOM / NAMES(',I3,'), TIMES(',I3,'),',/,
     $ '     $ NCALLS(',I3,'), TIME(40), TRACE(40), NNUM(40), NT, ',/,
     $ '     $ NPRINT, OVERHD',/,
     $        '      CHARACTER *8 NAMES, TRACE',/,
     $        '      NPRINT = ',I1,/,
     $        '      NT     = 1' )
910   FORMAT ('      STATUS = LIB$INIT_TIMER()',/,
     $        '      STATUS = LIB$STAT_TIMER(2,ITIME,)',/,
     $        '      TIME(1) = FLOAT(ITIME)',/,
     $        '      NNUM(1) = 1',/,
     $        '      NCALLS(1) = 1')
920   FORMAT ('      RETURN',/,
     $        '      END',/,
     $        '      SUBROUTINE Q1QIN(N)',/,
     $ '      COMMON / Q1QCOM / NAMES(',I3,'), TIMES(',I3,'),',/,
     $ '     $ NCALLS(',I3,'), TIME(40), TRACE(40), NNUM(40), NT, ',/,
     $ '     $ NPRINT, OVERHD',/,
     $        '      CHARACTER *8 NAMES, TRACE',/,
     $        '      NT=NT + 1' )
930   FORMAT ('      STATUS = LIB$STAT_TIMER(2,ITIME,)',/,
     $        '      TIME(NT) = FLOAT(ITIME)',/,
     $        '      NCALLS(N) = NCALLS(N) + 1',/,
     $        '      NNUM(NT) = N',/,
     $        '      TIMES(NNUM(NT-1))=TIMES(NNUM(NT-1))+',
     $        'TIME(NT)-TIME(NT-1)-OVERHD')
940   FORMAT ('      TRACE(NT) = NAMES(N)',/,
     $        '      WRITE(NPRINT,900)(TRACE(I),I=1,NT)',/,
     $        '900   FORMAT(''0----TRACEBACK '',',/,
     $        '     $  4(5X,10(A8,3X)/))' )
950   FORMAT ('      RETURN',/,
     $        '      END',/,
     $        '      SUBROUTINE Q1QOUT(N)',/,
     $ '      COMMON / Q1QCOM / NAMES(',I3,'), TIMES(',I3,'),',/,
     $ '     $ NCALLS(',I3,'), TIME(40), TRACE(40), NNUM(40), NT, ',/,
     $ '     $ NPRINT, OVERHD',/,
     $        '      CHARACTER *8 NAMES, TRACE' )
960   FORMAT ('      STATUS = LIB$STAT_TIMER(2,ITIME,)',/,
     $        '      TOTAL = FLOAT(ITIME)',/,
     $        '      TIMES(N) = TIMES(N)+TOTAL-TIME(NT)-OVERHD')
970   FORMAT ('      NT = NT - 1',/,
     $        '      IF(NT.GT.0)TIME(NT)=TOTAL')
980   FORMAT ('      WRITE (NPRINT,900)(TRACE(I),I=1,NT)',/,
     $        '900   FORMAT ('' ----TRACEBACK '',',/,
     $        '     $ 4(5X,10(A8,3X)/))')
990   FORMAT ('      RETURN',/,
     $        '      END',/,
     $        '      SUBROUTINE Q1QSUM',/,
     $ '      COMMON / Q1QCOM / NAMES(',I3,'), TIMES(',I3,'),',/,
     $ '     $ NCALLS(',I3,'), TIME(40), TRACE(40), NNUM(40), NT, ',/,
     $ '     $ NPRINT, OVERHD',/,
     $        '      CHARACTER *8 NAMES, TRACE',/,
     $        '      CHARACTER *1 STAR',/,
     $        '      DATA STAR/''*''/' )
9000  FORMAT ('      STATUS = LIB$STAT_TIMER(2,ITIME,)',/,
     $        '      TOTAL = FLOAT(ITIME)',/,
     $        '      TIMES(1) = TIMES(1) + TOTAL - TIME(1) - OVERHD' )
9010  FORMAT ('      WRITE(NPRINT,900)',/,
     $        '900   FORMAT(''1'',10X,',/,
     $        '     $ ''******** PROCESSING ENDED AT STOP *******'' ',
     $        ',/////)' )
9020  FORMAT ('      WRITE(NPRINT,930)',/,
     $        '930   FORMAT('' SUBPROGRAM '',1X,''NO. OF'',2X,',/,
     $        '     $ ''CPU TIME'',10X,''PERCENT OF TOTAL'',/,',/,
     $        '     $ '' NAME'',8X,''CALLS'',3X,''(SEC)'',13X,',/,
     $        '     $ ''(.5 PERCENT PER STAR)'' ,/)',/,
     $        '      TOTAL = 0.0',/,
     $        '      DO 5 I = 1,',I3,/,
     $        '         TIMES(I) = TIMES(I)/100.0',/,
     $        '         TOTAL = TOTAL + TIMES(I)',/,
     $        '5        CONTINUE',/,
     $        '      DO 10 I = 1,',I3,/,
     $     '         NUMB = MIN0(INT(200*(TIMES(I)/TOTAL) + 0.5),100)',/,
     $        '         WRITE(NPRINT,940)NAMES(I),NCALLS(I),TIMES(I)',
     $                  ',(STAR,J=1,NUMB)',/,
     $        '940      FORMAT(1X,A8,1X,I7,2X,F10.4,2X,100A1)',/,
     $        '10       CONTINUE',/,
     $        '      WRITE(NPRINT,945)TOTAL',/,
     $        '945   FORMAT(/,'' TOTAL '',12X,F10.4)')
9030  FORMAT ('      RETURN',/,
     $        '      END',/,
     $ '      BLOCK DATA',/,
     $ '      COMMON / Q1QCOM / NAMES(',I3,'), TIMES(',I3,'),',/,
     $ '     $ NCALLS(',I3,'), TIME(40), TRACE(40), NNUM(40), NT, ',/,
     $ '     $ NPRINT, OVERHD',/,
     $ '      CHARACTER *8 NAMES, TRACE',/,
     $ '      DATA TIME/40*0.0/, TIMES/',I3,'*0.0/',/,
     $ '      DATA OVERHD/0.053/',/,
     $ '      DATA TRACE(1)/''MAIN  ''/',/,
     $ '      DATA NAMES/' )
9040  FORMAT (5X,A72)
9050  FORMAT ('      END')
      END
C
C---END FOROUT
C
      SUBROUTINE CHECKC
C* 
C*                  ******************************* 
C*                  ******************************* 
C*                  **                           ** 
C*                  **          CHECKC           ** 
C*                  **                           ** 
C*                  ******************************* 
C*                  ******************************* 
C* 
C*     SUBPROGRAM : 
C*          CHECK CALLS TO SUBROUTINES
C* 
C*     AUTHOR : 
C*          ART RAGOSTA 
C*          MS 207-5 
C*          AMES RESEARCH CENTER 
C*          MOFFETT FIELD, CALIF 94035 
C*          (415)965-5578 
C* 
C*     PURPOSE : 
C*          CHECK THE LIST OF SUBROUTINES FOR A CALL TO THEM.
C* 
C*     COMMON BLOCKS : 
C*          STORE, SWITCH
C* 
C*     FILE REFERENCES : 
C*          NPRINT
C* 
C*     SUBPROGRAM REFERENCES : 
C*          SORTR, SEARCH1
C* 
C*     LANGUAGE AND COMPILER : 
C*          ANSI FORTRAN 77
C* 
C*     VERSION AND DATE : 
C*          VERSION I.0
C* 
C*     CHANGE HISTORY : 
C*          03/24/86      INITIAL VERSION 
C* 
C***********************************************************************
C* 
      PARAMETER (MXCHR=12)
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / STORE  / FUNNAM(50), SUBNAM(400), CALNAM(400), 
     $  NARGS(400), NARGC(400), NUMS, NUMF, NUMC, SAVE
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      LOGICAL SAVE
      CHARACTER *(MXCHR) FUNNAM, CALNAM, SUBNAM, TEMP(400) 
      DIMENSION IND(400)     
C
C --- SORT CALLED NAME ARRAY FOR "SEARCH1"
C
      DO 10 I=1,NUMC
         TEMP(I) = CALNAM(I)
10       CONTINUE
      CALL SORTR ( TEMP, NUMC, IND )
C
C --- SEARCH FOR EACH SUBROUTINE NAME (EXCEPT MAIN)
C
      DO 20 I=2,NUMS
         CALL SEARCH1 ( TEMP, NUMC, SUBNAM(I), K, MATCH )
         IF (.NOT. MATCH) THEN
           WRITE(NPRINT,900) SUBNAM(I)
           NERROR = NERROR + 1
         ENDIF
20    CONTINUE
      RETURN
900   FORMAT(/,
     $' ******* ERROR, Subroutine ',A,' is not called by any routine',
     $/,' *******        within this file.')
      END
C
C---END CHECKC
C
      SUBROUTINE SUMMAR 
C* 
C*                  ******************************* 
C*                  ******************************* 
C*                  **                           ** 
C*                  **          SUMMAR           ** 
C*                  **                           ** 
C*                  ******************************* 
C*                  ******************************* 
C* 
C*     SUBPROGRAM : 
C*          SUMMARIZE 
C* 
C*     AUTHOR : 
C*          ART RAGOSTA 
C*          MS 207-5 
C*          AMES RESEARCH CENTER 
C*          MOFFETT FIELD, CALIF 94035 
C*          (415)965-5578 
C* 
C*     PURPOSE : 
C*          PRODUCE HEADER AND SUMMARIZE THE STATISTICS FOUND. 
C* 
C*     COMMON BLOCKS : 
C*          STORE, SWITCH, CHARTX
C* 
C*     FILE REFERENCES : 
C*          NSUMM
C* 
C*     SUBPROGRAM REFERENCES : 
C*          DATE, TIME, CENTER
C* 
C*     TRANSPORTABILITY LIMITATIONS : 
C*          SYSTEM-SPECIFIC DATE ROUTINE
C* 
C*     LANGUAGE AND COMPILER : 
C*          ANSI FORTRAN 77
C* 
C*     VERSION AND DATE : 
C*          VERSION II.3
C* 
C*     CHANGE HISTORY : 
C*          11/16/87     CARRIAGECONTROL = 'LIST' ADDED
C*          03/24/86     NUMBER OF SUBROUTINES AND FUNCTIONS ADDED
C*          07/30/85     FILENAME ADDED TO PRINTOUT
C*          06/05/84     NEW PRINT FORMAT ADDED
C*          03/12/84     CALLS CROSS-REFERENCE ADDED
C*          01/24/84     CONVERTED TO VAX
C*          10/13/83     INITIAL VERSION 
C* 
C***********************************************************************
C* 
      PARAMETER (MXCHR=12)
      COMMON / STORE  / FUNNAM(50), SUBNAM(400), CALNAM(400), 
     $  NARGS(400), NARGC(400), NUMS, NUMF, NUMC, SAVE
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / CHARTX / CHRT(200), PROPST
      CHARACTER *200 CHRT
      CHARACTER *132 PROPST
      CHARACTER *97 DIREC
      CHARACTER *(MXCHR) FUNNAM, CALNAM, SUBNAM 
      CHARACTER *9 ADATE
      CHARACTER *8 ATIME
      CHARACTER *1 FF
      LOGICAL SAVE
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      DATA FF /12/
C 
      OPEN (UNIT=NSUMM, STATUS='NEW', CARRIAGECONTROL='LIST',ERR=1000)
      WRITE (NSUMM, 930) FF
      CALL DATE ( ADATE )
      CALL TIME ( ATIME )
      DIREC = ' '
      DO 5 I=1,4
         READ(NDIR,930,END=10,ERR=10) DIREC
5     CONTINUE
10    CALL CENTER ( DIREC )
      WRITE (NSUMM,900)DIREC,ATIME(1:5),ADATE
      NBREAK = 67
15    NBREAK = NBREAK-1
      IF (PROPST(NBREAK:NBREAK) .NE. ',') GO TO 15
      WRITE (NSUMM,910)PROPST(1:NBREAK),PROPST(NBREAK+1:132),NSTMTS
      IF ((.NOT. RUNC) .AND. (.NOT.RUNT)) THEN
         WRITE (NSUMM,923)
      ELSE IF ( RUNC ) THEN
         WRITE(NSUMM,915) NUMS,NUMF
         WRITE (NSUMM,920) NERROR
      ENDIF
      WRITE (NSUMM,925)
C
C --- TRACER PRINTOUT
C
      IF (RUNT) WRITE(NSUMM,940)
      CLOSE (UNIT=NSUMM)
      RETURN
1000  WRITE (NPRINT,999)
      RETURN
900   FORMAT (////,
     $ 100('*'),/,'*',T100,'*',
     $/'*         ------  PREBUG',T57,
     $ 'VERSION III.11 (05 - OCT - 1992) ------',T100,'*',/,
     $ 2('*',T100,'*',/),
     $ '*',A98,'*',
     $/'*                   ------   STATUS OF DATA SET AS OF ',
     $ A5,' ',A9,T73,'------',T100,'*',
     $/'*',T100,'*',/,'*',T100,'*',/,'*',T100,'*')
910   FORMAT (
     $ '*             OPTIONS = ',A,T100,'*',/,'*',T24,A,T100,'*',
     $/,'*',T100,'*',/,
     $ '*                ------ ',I6,' STMTS READ',T80,
     $                         '------              *')
915   FORMAT ('*',T100,'*',/,
     $ '*                ------ ',I6,' SUBROUTINES FOUND',T80,
     $                         '------              *',/,
     $ '*',T100,'*',/,
     $ '*                ------ ',I6,' FUNCTIONS FOUND',T80,
     $                         '------              *',/,
     $ '*',T100,'*',/,
     $ 100('*'))
920   FORMAT ('*',T100,'*',/,
     $'*                 ------ ',I5,' ERRORS DETECTED',T79,
     $'------               *')
923   FORMAT ('*',T100,'*',/,
     $'*                     NO OPTIONS CHOSEN --- ',
     $'INPUT COPIED TO BUGOUT.FOR',T100,'*')
925   FORMAT ('*',T100,'*',/,100('*'))
930   FORMAT(A)
940   FORMAT(///,T30,'*****                                *****',/,
     $           T30,'*****  AN INSTRUMENTED PROGRAM HAS   *****',/,
     $           T30,'*****  BEEN CREATED AS "BUGOUT.FOR"  *****',/,
     $           T30,'*****  AND COMPILED TO "BUGOUT.OBJ". *****',/,
     $           T30,'*****  YOU MUST LINK AND RUN IT TO   *****',/,
     $           T30,'*****  GET YOUR TIME/TRACE INFO.     *****',/,
     $           T30,'*****                                *****')
999   FORMAT (' ***** ERROR OPENING SUMMARY FILE,',
     $        ' NO SUMMARY PRODUCED.')
      END 
C
C---END SUMMAR
C
      SUBROUTINE SAVER
C* 
C*                  ******************************* 
C*                  ******************************* 
C*                  **                           ** 
C*                  **          SAVER            ** 
C*                  **                           ** 
C*                  ******************************* 
C*                  ******************************* 
C* 
C*     SUBPROGRAM : 
C*          SAVE
C* 
C*     AUTHOR : 
C*          ART RAGOSTA 
C*          MS 207-5 
C*          AMES RESEARCH CENTER 
C*          MOFFETT FIELD, CALIF 94035 
C*          (415)965-5578 
C* 
C*     PURPOSE : 
C*          SAVE STATUS OF PROGRAM FOR LATER CONTINUATION.
C* 
C*     COMMON BLOCKS : 
C*          STORE, SWITCH, LITTLE
C* 
C*     FILE REFERENCES : 
C*          NSAVE
C* 
C*     LANGUAGE AND COMPILER : 
C*          ANSI FORTRAN 77
C* 
C*     VERSION AND DATE : 
C*          VERSION I.0     12/26/84
C* 
C*     CHANGE HISTORY : 
C*          12/26/84     INITIAL VERSION 
C* 
C***********************************************************************
C* 
      PARAMETER (MXCHR=12)
      COMMON / STORE  / FUNNAM(50), SUBNAM(400), CALNAM(400), 
     $  NARGS(400), NARGC(400), NUMS, NUMF, NUMC, SAVE
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / LITTLE / NSUB, SAVNAM
      LOGICAL SAVE
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      CHARACTER *20 SAVNAM
      CHARACTER *(MXCHR)  FUNNAM, CALNAM, SUBNAM 
C
      OPEN ( UNIT=NSAVE, STATUS='NEW', FILE=SAVNAM,
     $  FORM='UNFORMATTED', ERR=1000 )
      WRITE ( NSAVE ) NUMS, NUMF, NUMC
      DO 100 I = 1, NUMS
         WRITE ( NSAVE ) SUBNAM(I), NARGS(I)
100      CONTINUE
      DO 200 I = 1, NUMF
         WRITE ( NSAVE ) FUNNAM(I)
200      CONTINUE
      DO 300 I = 1, NUMC
         WRITE ( NSAVE ) CALNAM(I), NARGC(I)
300      CONTINUE
      CLOSE ( UNIT=NSAVE )
      RETURN
1000  WRITE ( NPRINT, 900 )
      NERROR = NERROR + 1
      RETURN
900   FORMAT(///,'  ******* UNABLE TO OPEN SAVE FILE.')
      END
C
C---END SAVER
C
      SUBROUTINE CHARTR 
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          CHARTR           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          CHARTER              
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CALIF 94035              
C*          (415)965-5578                           
C*
C*     PURPOSE :
C*          PRINT OUT THE CALL STMT / SUBPROGRAM CROSS-REFERENCE CHART
C*
C*     INTERNAL WORK AREAS :
C*          BLOCK - CONTAINS THE TEXT FOR THE UPPER,LEFT-HAND CORNER
C*          CROW  - ONE ROW OF THE CHART, WHILE IT IS BEING BUILT
C*
C*     COMMON BLOCKS :
C*          STORE, SWITCH, CHARTX
C*
C*     FILE REFERENCES :
C*          NPRINT - PRINT OUT CROSS-REFERENCE CHART
C*
C*     SUBPROGRAM REFERENCES :
C*          SORTR
C*
C*     ASSUMPTIONS AND RESTRICTIONS :
C*          PRINTOUT ASSUMES 133 COLUMN OUTPUT
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION II.1     JUNE 5, 1984
C*
C*     CHANGE HISTORY :
C*          10/05/92     INCREASED VARIABLE NAME PRINTOUT TO 10 CHARS.
C*          06/05/84     SORT OPTION ADDED
C*          03/12/84     INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (MXCHR=12)
      COMMON / STORE  / FUNNAM(50), SUBNAM(400), CALNAM(400), 
     $  NARGS(400), NARGC(400), NUMS, NUMF, NUMC, SAVE
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / CHARTX / CHRT(200), OPST
      LOGICAL SAVE
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      DIMENSION INDX(400)
      CHARACTER *200 CHRT
      CHARACTER *132 OPST
      CHARACTER *120 CROW
      CHARACTER *11 BLOCK(10)
      CHARACTER *(MXCHR) FUNNAM, CALNAM, SUBNAM 
      CHARACTER *1 FF
      DATA BLOCK/ ' CALL STM :',
     $            ' \        :',
     $            '   \      :',
     $            '     \    :', 
     $            '       \  :',
     $            'SUB-     \:',
     $            'PROGRAMS  :',
     $            '          :',
     $            '          :',
     $            '          :'/
      DATA FF /12/
C
C --- SORT ALL SUBPROGRAM NAMES EXCEPT FIRST (MAIN)
C ---  NOSORT OPTION IS HANDLED IN ROUTINE SORT
C
      IF ( NUMS .GT. 200) THEN
         NUMSX = 200
      ELSE
         NUMSX = NUMS
      ENDIF
      DO 5 I=1,NUMSX
         INDX(I) = I
5        CONTINUE
      IF (SORT) CALL SORTR ( SUBNAM(2), NUMSX-1, INDX(2))
      ISTART = 1
      IF ( NUMC .GT. 200 ) THEN
         NUMCX = 200
      ELSE
         NUMCX = NUMC
      ENDIF
      IF ( NUMCX .GT. 32 ) THEN
         NEND = 32
      ELSE
         NEND = NUMCX
      ENDIF
C
C --- PRINT MAP HEADER
C
10    WRITE(NPRINT,940) FF
      DO 20 I = 1,10
         WRITE(NPRINT,900)BLOCK(I),(CALNAM(J)(I:I),J=ISTART,NEND)
20       CONTINUE
      WRITE(NPRINT,910)
C
C --- PRINT ONE ROW OF MAP
C
      DO 30 I = 1, NUMSX
         CROW = ' '
         IPTR = 1
         DO 25 II = ISTART, NEND
C
C --- CROW IS THE FULL ROW TO BE PRINTED
C
            CROW(IPTR:IPTR+2) = '  '//CHRT(INDX(I))(II:II)
            IPTR = IPTR + 3
            IF ( MOD(II,4) .EQ. 0 ) THEN
               IF ( IPTR .LT. 110 ) THEN
                  CROW(IPTR:IPTR+2) = '  .'
                  IPTR = IPTR + 3
               ENDIF
            ENDIF
25       CONTINUE
         CROW(120:120) = '.'
         WRITE(NPRINT,920)SUBNAM(I),CROW
         IF (MOD(I,3) .EQ. 0) WRITE(NPRINT,925)
30       CONTINUE
C
C --- IF THE NUMBER OF CALL STATEMENTS IS TOO GREAT TO FIT ACROSS THE TOP
C ---  OF A SINGLE PAGE, SET THE START AND STOP INDICES FOR THE NEXT SET
C
      ISTART = NEND + 1
      NEND   = ISTART + 31
      IF ( NEND .GT. NUMCX ) NEND = NUMCX
      IF ( NEND .GE. ISTART ) GO TO 10
      RETURN
900   FORMAT (A11,8(4(2X,A1),'  .'))
910   FORMAT (132('-'))
920   FORMAT (A10,':',A120)
925   FORMAT (10X,':',8(14X,'.'))
940   FORMAT (A,//)
      END
C
C---END CHARTR
C
      SUBROUTINE SORTR ( ARRAY, NUM, INDX )
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **           SORT            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          SORT ARRAY
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CALIF 94035              
C*          (415)965-5578                           
C*
C*     PURPOSE :
C*          PRODUCE A SORTED INDEX POINTER ARRAY
C*
C*     METHODOLOGY :
C*          SHELLSORT                        
C*
C*     INPUT ARGUMENTS :
C*          NUM    - NUMBER OF ELEMENTS IN ARRAY
C*          INDX   - INDEX ARRAY
C*          ARRAY  - ARRAY TO BE SORTED
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION II.1     JUNE 5, 1984
C*
C*     CHANGE HISTORY :
C*          06/05/84     INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (MXCHR=12)
      DIMENSION ARRAY(1), INDX(1)
      CHARACTER *(*) ARRAY
      CHARACTER *(MXCHR) TEMPA
      INTEGER TEMPI
      LOGICAL DONE
C
      IF (NUM .LE. 1) RETURN
      JUMP = NUM
20    JUMP = JUMP / 2
30    DONE = .TRUE.
      NJ   = NUM-JUMP
      DO 40 J = 1, NJ
         I = J + JUMP
         IF (ARRAY(J) .GT. ARRAY(I))THEN
            DONE     = .FALSE.
            TEMPA    = ARRAY(J)
            ARRAY(J) = ARRAY(I)
            ARRAY(I) = TEMPA
            TEMPI    = INDX(J)
            INDX(J)  = INDX(I)
            INDX(I)  = TEMPI
         ENDIF
40       CONTINUE
      IF (.NOT. DONE) GO TO 30
      IF (JUMP .GT. 1) GO TO 20
      RETURN
      END
C
C---END SORT
C
      LOGICAL FUNCTION FASSUR ( STRING )
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          FASSUR           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          ASSURE STATEMENT TYPE                   
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA  94035                
C*          (415) 965-5578                          
C*
C*     PURPOSE :
C*          TO ASSURE THAT THE INDEX OF THE STATEMENT KEYWORD WAS       
C*          NOT IN A LITERAL FIELD.                                     
C*
C*     METHODOLOGY :
C*          REMOVE SPACES AND CHECK FOR THE KEYWORD IN THE FIRST        
C*          COLUMNS OF THE RESULTING STRING.                            
C*
C*     INPUT ARGUMENTS :
C*          STRING - THE STATEMENT IDENTIFICATION STRING(EG, 'FUNCTION')
C*
C*     OUTPUT VALUE :
C*          TRUE IF THE STRING WAS FOUND FIRST IN THE STATEMENT...
C*           FALSE OTHERWISE.
C*
C*     INTERNAL WORK AREAS :
C*          WORK - HOLDS THE PACKED STRING
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     18-SEP-84 
C*
C*     CHANGE HISTORY :
C*          18-SEP-84    INITIAL VERSION
C*
C***********************************************************************
C*
      CHARACTER *(*) STRING
C
C --- CHECK TO SEE IF THE KEYWORD WAS FOUND
C
      FASSUR = .FALSE.
      IF ((STRING(1:4) .EQ. 'FUNC') .OR. (STRING(1:4) .EQ. 'LOGI') .OR.
     $    (STRING(1:4) .EQ. 'INTE') .OR. (STRING(1:4) .EQ. 'REAL') .OR.
     $    (STRING(1:4) .EQ. 'DOUB') .OR. (STRING(1:4) .EQ. 'COMP') .OR.
     $    (STRING(1:4) .EQ. 'CHAR')) FASSUR = .TRUE.
      RETURN
      END
C
C---END FASSUR
C
      SUBROUTINE ENDUP
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          ENDUP            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          END UP STUFF                            
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA 94035                 
C*          (415) 694-5578                          
C*
C*     PURPOSE :
C*          TAKE CARE OF END-OF-FILE PROCESSING
C*
C*     COMMON BLOCKS :
C*          SWITCH, STORE
C*
C*     SUBPROGRAM REFERENCES :
C*          FOROUT, CHECKC, SUMMAR, SAVER, CHARTR
C*
C*     ERROR PROCESSING :
C*          NONE
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0      9-SEP-86 
C*
C*     CHANGE HISTORY :
C*           9-SEP-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (MXCHR=12)
      COMMON / SWITCH / LENST, MAP, RUNC, RUNT, NPRINT, NSUMM, NREAD,
     $   NSTMTS, NERROR, NOUT, SORT, NSAVE, LTIME, LTRACE,
     $   LINDEX, NCODE, NDIR, ISTART
      COMMON / STORE  / FUNNAM(50), SUBNAM(400), CALNAM(400), 
     $  NARGS(400), NARGC(400), NUMS, NUMF, NUMC, SAVE
      CHARACTER *(MXCHR) FUNNAM, CALNAM, SUBNAM 
      LOGICAL MAP, RUNT, RUNC, SORT, LTIME, LTRACE, LINDEX
      LOGICAL SAVE
C
      IF (RUNT) CALL FOROUT
      IF (RUNC) THEN
         CALL CHECKC
      ENDIF
      CALL SUMMAR
      IF ( SAVE ) CALL SAVER
      IF ( MAP )  CALL CHARTR
      STOP
      END
C
C---END ENDUP
C
      BLOCK DATA
      COMMON / MATCH / NAMES(500), NNAMES
      CHARACTER *8 NAMES
C
      DATA NNAMES/1/
      DATA NAMES(1)/'MAIN  '/
      END
C
C---END BLOCK DATA
C
C----END FILE
C
