      PROGRAM REORDER
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          REORDE           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          REORDER                                 
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          REORDER THE SUBPROGRAMS IN A FORTRAN SOURCE DECK.           
C*
C*     SUBPROGRAM REFERENCES :
C*          SETUP, READFILE, BUILDOUT, WRITEFILE
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     16-JAN-86 
C*
C*     CHANGE HISTORY :
C*          16-JAN-86    INITIAL VERSION
C*
C***********************************************************************
C*
      CALL SETUP
      CALL READFILE
      CALL BUILDOUT
      CALL WRITEFILE
      STOP
      END
C
C---END REORDER
C
      SUBROUTINE SETUP
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          SETUP            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          SET UP                                  
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          SETUP THE OPTIONS AND FILES.                                
C*
C*     COMMON BLOCKS :
C*          STUFF, FILES
C*
C*     FILE REFERENCES :
C*          5, 6, 60, 61, 62
C*
C*     SUBPROGRAM REFERENCES :
C*          GETFOR, PROMPT
C*
C*     ERROR PROCESSING :
C*          NORMAL PROCESSING DONE BY OPENS
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     16-JAN-86 
C*
C*     CHANGE HISTORY :
C*          16-JAN-86    INITIAL VERSION
C*
C***********************************************************************
C*
C
C --- CHECK FILE EXISTS, CHECK FOR VALID ORDER OPTION
C                                                        
      PARAMETER (MAXS=100)
      COMMON / STUFF / FNAME, IOUT, NUM, NLINE, LINE, NAMES(MAXS),
     $  START(MAXS), ENDS(MAXS), INDX(MAXS), OUTLIS(MAXS), INUM
      COMMON /FILES/ NKEY, NOUT, NIN, NFIL, NTEMP, NNEW     
      DATA NKEY, NOUT, NIN, NFIL, NTEMP, NNEW /5, 6, 60, 61, 62, 63/
      CHARACTER *80 LINE
      CHARACTER *20 FNAME, NAMES, OUTLIS
      INTEGER START,ENDS
C
      CHARACTER *20 Q(4), P(4), TEMP
C
      CALL GETFOR(NQ,Q,NP,P)
      IF (NP .GT. 1) WRITE(NOUT,900)
C
C --- FILE NAME
C
      IF (NP .GT. 0) THEN
         FNAME = P(1)
      ELSE
         CALL PROMPT(NOUT,' File ? ')
         READ(NKEY,910) FNAME
         IF (FNAME .EQ. ' ') STOP
      ENDIF            
      IF (INDEX(FNAME,'.') .EQ. 0) 
     $   FNAME = FNAME(1:LENGTH(FNAME))//'.FOR'
      TEMP = FNAME
      OPEN(UNIT=NIN,NAME=FNAME,STATUS='OLD',ERR=1000)
C
C --- ORDER OPTION
C
      IF (NQ .GT. 1) WRITE(NOUT,930)         
      IF (NQ .EQ. 0) THEN
         IOUT = -1
      ELSE    
         IEQUAL = INDEX(Q(1),'=')
         IF (IEQUAL .EQ. 0) THEN
            WRITE(NOUT,930)
            STOP
         ENDIF
         TEMP = Q(1)(IEQUAL+1:)
         IF (TEMP .EQ. 'ALPHA') THEN
            IOUT = 0
         ELSE
            IOUT = 1
            OPEN(UNIT=NFIL,NAME=TEMP,STATUS='OLD',ERR=1000)
         ENDIF
      ENDIF                 
C
C --- OPEN DIRECT ACCESS FILE
C                                        
      TEMP = 'SCRATCH FILE'
      OPEN(UNIT=NTEMP,NAME='TEMP.TMP',STATUS='NEW',
     $ CARRIAGECONTROL='LIST',ACCESS='DIRECT',RECL=80,FORM='FORMATTED',
     $ DISP='DELETE',ERR=1000)
C
C --- INITIALIZE POINTERS
C
      NUM = 0
      NLINE = 0
      RETURN                                       
1000  WRITE(NOUT,920)TEMP
      STOP
900   FORMAT(' *** Extra parameters ignored.')
910   FORMAT(A)
920   FORMAT(' *** Unable to open file ',A)
930   FORMAT(' *** Extra qualifiers ignored.')
      END
C
C---END SETUP
C
      SUBROUTINE READFILE
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          READFI           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          READ FILE                               
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          READ THE FILE AND STORE IT ON THE DIRECT ACCESS FILE;       
C*          NOTE THE START AND END OF THE SUBPROGRAM.                   
C*
C*     COMMON BLOCKS :
C*          STUFF, FILES
C*
C*     FILE REFERENCES :
C*          6, 60, 62
C*
C*     SUBPROGRAM REFERENCES :
C*          CHECKNEW
C*
C*     TRANSPORTABILITY LIMITATIONS :
C*          NAME OF SUBROUTINE TOO LONG
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     16-JAN-86 
C*
C*     CHANGE HISTORY :
C*          16-JAN-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (MAXS=100)
      COMMON / STUFF / FNAME, IOUT, NUM, NLINE, LINE, NAMES(MAXS),
     $  START(MAXS), ENDS(MAXS), INDX(MAXS), OUTLIS(MAXS), INUM
      COMMON /FILES/ NKEY, NOUT, NIN, NFIL, NTEMP, NNEW     
      CHARACTER *80 LINE
      CHARACTER *20 FNAME, NAMES, OUTLIS
      INTEGER START,ENDS
C
      CHARACTER *20 NAME                                   
      LOGICAL ISNEW
C
      WRITE(NOUT,910)
10    READ(NIN,900,END=1000) LINE
      NLINE = NLINE + 1
      WRITE(NTEMP,REC=NLINE,FMT=900)LINE
      CALL CHECKNEW(ISNEW,NAME)
      IF (ISNEW) THEN
         NUM = NUM + 1
         NAMES(NUM) = NAME
         START(NUM) = NLINE
         IF (NUM .NE. 1) ENDS(NUM-1) = NLINE-1
      ENDIF
      GO TO 10
C
1000  ENDS(NUM) = NLINE
      RETURN                   
900   FORMAT(A)   
910   FORMAT(' Starting read pass.')
      END
C
C--END READFILE
C                      
      SUBROUTINE CHECKNEW(ISNEW,NAME)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          CHECKN           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          CHECK FOR NEW SUBPROGRAM                
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          CHECK THIS LINE TO SEE IF IT IS THE FIRST LINE IN A         
C*          NEW SUBPROGRAM.                                             
C*
C*     OUTPUT ARGUMENTS :
C*          ISNEW  - IS THIS A NEW SUBPROGRAM ?
C*          NAME   - THE NAME OF THE SUBPROGRAM IF SO
C*
C*     COMMON BLOCKS :
C*          STUFF
C*
C*     SUBPROGRAM REFERENCES :
C*          BLANKS, GETNAME, LENGTH
C*
C*     TRANSPORTABILITY LIMITATIONS :
C*          LONG SUBPROGRAM NAMES
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     16-JAN-86 
C*
C*     CHANGE HISTORY :
C*          16-JAN-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (MAXS=100)
      COMMON / STUFF / FNAME, IOUT, NUM, NLINE, LINE, NAMES(MAXS),
     $  START(MAXS), ENDS(MAXS), INDX(MAXS), OUTLIS(MAXS), INUM
      CHARACTER *80 LINE
      CHARACTER *20 FNAME, NAMES, OUTLIS
      INTEGER START,ENDS
C
      CHARACTER *74 TLINE
      CHARACTER *20 NAME, TEMP
      LOGICAL ISNEW     
C
      TLINE = LINE(7:)
      CALL BLANKS(TLINE)
      ISNEW = .FALSE.
      IF (TLINE(1:10) .EQ. 'SUBROUTINE') THEN
         ISNEW = .TRUE.
         CALL GETNAME(TLINE,NAME,11)
      ELSE IF (TLINE(1:7) .EQ. 'PROGRAM') THEN
         ISNEW = .TRUE.             
         CALL GETNAME(TLINE,NAME,8)
      ELSE IF (TLINE(1:9) .EQ. 'BLOCKDATA') THEN
         ISNEW = .TRUE.            
         NAME = 'BLOCK DATA'
      ELSE IF (INDEX(TLINE,'FUNCTION') .NE. 0) THEN
         TEMP = TLINE(1:4)
         IF ((TEMP .EQ. 'INTE') .OR. (TEMP .EQ. 'REAL') .OR.
     $       (TEMP .EQ. 'DOUB') .OR. (TEMP .EQ. 'LOGI') .OR.
     $       (TEMP .EQ. 'CHAR') .OR. (TEMP .EQ. 'COMP')) THEN
            ISNEW = .TRUE.
            CALL GETNAME(TLINE,NAME,INDEX(TLINE,'FUNCTION')+8)
         ENDIF
      ENDIF
      RETURN  
      END
C
C---END CHECKNEW
C
      SUBROUTINE BUILDOUT
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          BUILDO           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          BUILD OUTPUT LIST                       
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          CREATE A LIST CONTAINING THE SUBPROGRAM NAMES IN THE        
C*          DESIRED OUTPUT ORDER.                                       
C*
C*     COMMON BLOCKS :
C*          STUFF, FILES
C*
C*     FILE REFERENCES :
C*          5, 6, 61
C*
C*     SUBPROGRAM REFERENCES :
C*          ISORT, CAPS
C*
C*     TRANSPORTABILITY LIMITATIONS :
C*          LONG SUBPROGRAM NAMES
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     16-JAN-86 
C*
C*     CHANGE HISTORY :
C*          16-JAN-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (MAXS=100)
      COMMON / STUFF / FNAME, IOUT, NUM, NLINE, LINE, NAMES(MAXS),
     $  START(MAXS), ENDS(MAXS), INDX(MAXS), OUTLIS(MAXS), INUM
      COMMON /FILES/ NKEY, NOUT, NIN, NFIL, NTEMP, NNEW     
      CHARACTER *80 LINE
      CHARACTER *20 FNAME, NAMES, OUTLIS
      INTEGER START,ENDS
C                                   
      WRITE(NOUT,910)
      CALL ISORT(NAMES,NUM,INDX)
C
C --- BASED UPON THE TYPE OF ORDERING, BUILD THE OUTPUT ORDER LIST
C ---- IF IOUT=-1 ENTER FROM KEYBOARD
C ----        =0  ALPHABETIZE
C ----        =1  READ ORDER FROM FILE
C
      IF (IOUT .LT. 0) THEN
         I = 1
10       READ(NKEY,900,END=15)OUTLIS(I)
         CALL CAPS(OUTLIS(I))
         I = I + 1
         IF (OUTLIS(I) .NE. 'END') GO TO 10
15       I = I - 1
      ELSE IF (IOUT .EQ. 0) THEN
         DO 20 I=1,NUM
            OUTLIS(I) = NAMES(I)
20          CONTINUE
      ELSE                    
         I = 1
30       READ(NFIL,900,END=35)OUTLIS(I)
         CALL CAPS(OUTLIS(I))
         I = I + 1
         IF (OUTLIS(I) .NE. 'END') GO TO 30
35       I = I - 1
      ENDIF
C
C --- IF IOUT=0 THEN NUM MUST EQUAL I, OTHERWISE CHECK IT
C
      INUM = I
      IF (IOUT .NE. 0) THEN
         IN = 1
         ITEMP = I
40       DO 50 J = 1, ITEMP
            IF(OUTLIS(J) .EQ. NAMES(IN)) THEN
               IN = IN + 1
               IF (IN .GT. NUM) RETURN
               GO TO 40
            ENDIF
50          CONTINUE
         INUM = INUM + 1
         OUTLIS(INUM) = NAMES(IN)
         IN = IN + 1
         IF (IN .LE. NUM) GO TO 40
      ENDIF
      RETURN             
900   FORMAT(A)   
910   FORMAT(' Starting order pass.')
      END
C
C---END BUILDOUT
C
      SUBROUTINE WRITEFILE
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          WRITEF           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          WRITE FILE                              
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          WRITE OUT THE FILE IN THE NEW ORDER.                        
C*
C*     COMMON BLOCKS :
C*          STUFF, FILES
C*
C*     FILE REFERENCES :
C*          6
C*
C*     SUBPROGRAM REFERENCES :
C*          FIND, OUT
C*
C*     ERROR PROCESSING :
C*          NORMAL OPEN ERROR CHECKING
C*
C*     TRANSPORTABILITY LIMITATIONS :
C*          LONG SUBPROGRAM NAMES
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     16-JAN-86 
C*
C*     CHANGE HISTORY :
C*          16-JAN-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (MAXS=100)
      COMMON / STUFF / FNAME, IOUT, NUM, NLINE, LINE, NAMES(MAXS),
     $  START(MAXS), ENDS(MAXS), INDX(MAXS), OUTLIS(MAXS), INUM
      COMMON /FILES/ NKEY, NOUT, NIN, NFIL, NTEMP, NNEW     
      CHARACTER *80 LINE
      CHARACTER *20 FNAME, NAMES, OUTLIS
      INTEGER START,ENDS
C                                    
      WRITE(NOUT,910)                 
      OPEN(UNIT=NNEW,NAME=FNAME,STATUS='NEW',CARRIAGECONTROL='LIST')
      DO 10 I = 1, NUM
         CALL FIND(OUTLIS(I),J)
         IF (J .LT. 1) THEN
            WRITE(NOUT,920) OUTLIS(I)
         ELSE
            CALL OUT(J)
         ENDIF
10       CONTINUE
      RETURN            
910   FORMAT(' Starting write pass.')
920   FORMAT(' *** Subprogram not in list: ',A)
      END
C
C---END WRITEFILE
C                
      SUBROUTINE FIND(TARGET,J)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          FIND             **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          FIND NAME                               
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          FIND THIS NAME IN THE LIST OF OUTPUT NAMES                  
C*
C*     INPUT ARGUMENTS :
C*          TARGET - THE NAME OF THE SUBPROGRAM TO FIND
C*
C*     OUTPUT ARGUMENTS :
C*          J  - THE INDEX TO THE TARGET IN 'NAMES'
C*
C*     COMMON BLOCKS :
C*          STUFF
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     16-JAN-86 
C*
C*     CHANGE HISTORY :
C*          16-JAN-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (MAXS=100)
      COMMON / STUFF / FNAME, IOUT, NUM, NLINE, LINE, NAMES(MAXS),
     $  START(MAXS), ENDS(MAXS), INDX(MAXS), OUTLIS(MAXS), INUM
      CHARACTER *80 LINE
      CHARACTER *20 FNAME, NAMES, OUTLIS
      INTEGER START,ENDS
C
      CHARACTER *20 TARGET
C
      DO 10 J=1,NUM
         IF (NAMES(J) .EQ. TARGET) RETURN
10       CONTINUE
      J = -1
      RETURN
      END
C
C---END FIND
C
      SUBROUTINE OUT(J)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          OUT              **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          OUTPUT                                  
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          OUTPUT THE SELECTED SUBPROGRAM.                             
C*
C*     INPUT ARGUMENTS :
C*          J  - THE POINTER TO THE SUBPROGRAM IN 'NAMES'
C*
C*     COMMON BLOCKS :
C*          STUFF, FILES
C*
C*     FILE REFERENCES :
C*          6, 82, 83
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     16-JAN-86 
C*
C*     CHANGE HISTORY :
C*          16-JAN-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (MAXS=100)
      COMMON / STUFF / FNAME, IOUT, NUM, NLINE, LINE, NAMES(MAXS),
     $  START(MAXS), ENDS(MAXS), INDX(MAXS), OUTLIS(MAXS), INUM
      COMMON /FILES/ NKEY, NOUT, NIN, NFIL, NTEMP, NNEW     
      CHARACTER *80 LINE
      CHARACTER *20 FNAME, NAMES, OUTLIS
      INTEGER START,ENDS
C
      DO 10 I = START(INDX(J)), ENDS(INDX(J))
         READ(NTEMP,REC=I,FMT=910) LINE
         WRITE(NNEW,910) LINE(1:MAX0(1,LENGTH(LINE)))
10       CONTINUE
      RETURN
910   FORMAT(A)
      END
C
C---END OUT
C
      SUBROUTINE GETNAME(LINE,NAME,ISTART)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          GETNAM           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          GET NAME                                
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 207-5                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          GET THE NAME OF THIS SUBPROGRAM FROM THE SOURCE LINE.       
C*
C*     INPUT ARGUMENTS :
C*          LINE   - THE SOURCE LINE
C*          ISTART - THE STARTING CHARACTER IN THE NAME
C*
C*     OUTPUT ARGUMENTS :
C*          NAME - THE NAME OF THE SUBPROGRAM
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     16-JAN-86 
C*
C*     CHANGE HISTORY :
C*          16-JAN-86    INITIAL VERSION
C*
C***********************************************************************
C*
      CHARACTER *(*) LINE
      CHARACTER *20 NAME
C
      NAME = ' '
      IN = 0   
      IS = ISTART
10    IN = IN + 1
      NAME(IN:IN) = LINE(IS:IS)
      IS = IS + 1
      IF ((LINE(IS:IS) .NE. ' ') .AND. 
     $    (LINE(IS:IS) .NE. '(')) GO TO 10
      RETURN     
      END
C
C---END GETNAME
C
